package es.gva.cit.catalog.csw.drivers;

import java.net.MalformedURLException;
import java.net.URI;
import java.net.URL;
import java.util.Collection;

import es.gva.cit.catalog.csw.drivers.profiles.CSWISO19115Profile;
import es.gva.cit.catalog.csw.drivers.profiles.CSWAbstractProfile;
import es.gva.cit.catalog.csw.drivers.profiles.CSWebRIMProfile;
import es.gva.cit.catalog.csw.parsers.CSWConstants;
import es.gva.cit.catalog.drivers.GetRecordsReply;
import es.gva.cit.catalog.drivers.profiles.IProfile;
import es.gva.cit.catalog.metadataxml.XMLNode;
import es.gva.cit.catalog.metadataxml.XMLTree;
import es.gva.cit.catalog.protocols.HTTPPostProtocol;
import es.gva.cit.catalog.querys.CatalogQuery;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id$
 * $Log$
 *
 */
/**
 * @author Jorge Piera LLodr (jorge.piera@iver.es)
 */
public class CSWISO19115CatalogServiceDriver extends CSWCatalogServiceDriver{
	public static String SERVICE_NAME = "CSW/ISO 19115";

	/*
	 * (non-Javadoc)
	 * @see es.gva.cit.catalogClient.drivers.ICatalogServiceDriver#getServiceName()
	 */
	public String getServiceName() {
		return SERVICE_NAME;
	}	
	
	/*
	 * (non-Javadoc)
	 * @see es.gva.cit.catalog.csw.drivers.CSWCatalogServiceDriver#retrieveResults(es.gva.cit.catalog.metadataxml.XMLNode)
	 */
	protected XMLNode[] retrieveResults(XMLNode root){
		XMLNode resultNode = XMLTree.searchNode(root, CSWConstants.SEARCH_RESULTS);
		if (resultNode == null){
			return new XMLNode[0];
		}
		XMLNode[] results = new XMLNode[resultNode.getNumSubNodes()];
		for (int i=0 ; i<resultNode.getNumSubNodes() ; i++){
			results[i] = resultNode.getSubNode(i);
		}
		return results;
	}
	
	/*
	 * (non-Javadoc)
	 * @see es.gva.cit.catalog.drivers.AbstractCatalogServiceDriver#getProfile()
	 */
	public IProfile getProfile() {
		return new CSWISO19115Profile();
	}

}
