
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalog.protocols;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.net.URL;
import java.util.Collection;

import org.apache.commons.httpclient.DefaultMethodRetryHandler;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.GetMethod;

import es.gva.cit.catalog.metadataxml.XMLTree;

/**
 * 
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class HTTPGetProtocol implements IProtocols {

/**
 * 
 * 
 * 
 * @return 
 * @param url 
 * @param object 
 * @param firstRecord 
 */
    public Collection doQuery(URL url, Object object, int firstRecord) {        
        NameValuePair[] parameters = (NameValuePair[]) object;
        InputStream is = null;
        ByteArrayInputStream output = null;
  
        //	Create an instance of HttpClient.
        HttpClient client = new HttpClient();
        // 	Create a method instance.
        GetMethod method = new GetMethod("http://" + url.getHost() + ":" +
                url.getPort() + url.getPath());
        // Provide custom retry handler is necessary
        DefaultMethodRetryHandler retryhandler = new DefaultMethodRetryHandler();
        retryhandler.setRequestSentRetryEnabled(false);
        retryhandler.setRetryCount(3);
        method.setMethodRetryHandler(retryhandler);
        method.setQueryString(parameters);
        System.out.println(method.getQueryString());
        try {
            // Execute the method.
            int statusCode = client.executeMethod(method);
            //System.out.println("QueryString>>> "+ method.getQueryString());
            if (statusCode != HttpStatus.SC_OK) {
                System.err.println("Fallo en el mtodo: " +
                    method.getStatusLine());
                return null;
            }
            // Process the answer
            is = method.getResponseBodyAsStream();
            byte[] buffer = new byte[256];
            String str = new String("");
            while (true) {
                int n = is.read(buffer);
                if (n < 0) {
                    break;
                }
                str = str + new String(buffer, 0, n);
            }
            is.close();
            System.out.println(str);
            if (str.equals("")) {
                output = null;
            } else {
                output = new ByteArrayInputStream(str.getBytes());
            }
        } catch (Exception e) {
            return null;
        } finally {
            // Release the connection.
            method.releaseConnection();
        }
        
        Collection col = new java.util.ArrayList();
        col.add(XMLTree.xmlToTree(output));
        return col;
    } 

/**
 * 
 * 
 * 
 * @return 
 * @param url 
 */
    public static boolean isProtocolSupported(URL url) {        
        return true;
    } 
 }
