package es.gva.cit.gazetteer.drivers;

import java.util.Collection;

import org.gvsig.i18n.Messages;

import es.gva.cit.catalog.metadataxml.XMLNode;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id$
 * $Log$
 *
 */
/**
 * @author Jorge Piera Llodr (jorge.piera@iver.es)
 */
public abstract class GazeteerCapabilitiesParser {
	protected IGazetteerServiceDriver driver = null;
	protected GazetteerCapabilities capabilities = null;
	
	public GazeteerCapabilitiesParser(IGazetteerServiceDriver driver,
			GazetteerCapabilities capabilities) {
		super();
		this.driver = driver;
		this.capabilities = capabilities;
	}
	
	public GazeteerCapabilitiesParser(IGazetteerServiceDriver driver) {
		super();
		this.driver = driver;
		this.capabilities = new GazetteerCapabilities();
	}
	
	/**
	 * It parses the server request
	 * @param node
	 */
	public void parse(Collection nodes){
		if ((nodes != null) && (nodes.size() > 0)){
			XMLNode node = (XMLNode)nodes.toArray()[0];
			if (node != null){
				parseCapabilities(node);
				return;
			}
		}
		capabilities.setAvailable(false);
		capabilities.setServerMessage(Messages.getText("errorNotParsedReply"));
		return;
	}
	
	/**
	 * It parses the server capabilities 
	 */
	protected abstract void parseCapabilities(XMLNode node);

	/**
	 * @return the capabilities
	 */
	public GazetteerCapabilities getCapabilities() {
		return capabilities;
	}
	
	
}
