
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package es.gva.cit.gazetteer.ui.search;
import java.awt.Dimension;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

import org.gvsig.i18n.Messages;

import es.gva.cit.catalog.utils.CatalogConstants;

/**
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class SearchUpperPanel extends JPanel {
	private javax.swing.JCheckBox areaCheckBox;
    private javax.swing.JPanel areaPanel;
    private javax.swing.JPanel leftPanel;
    private javax.swing.JLabel nameLabel;
    private javax.swing.JPanel namePanel;
    private javax.swing.JTextField nameText;
    private javax.swing.JButton resizeButton;
    private javax.swing.JPanel resizePanel;
	/** Creates new form upperPanel */
	public SearchUpperPanel() {
		initComponents();
		initLabels();
	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	// <editor-fold defaultstate="collapsed" desc=" Cdigo Generado  ">                          
	private void initComponents() {
		   java.awt.GridBagConstraints gridBagConstraints;

	        namePanel = new javax.swing.JPanel();
	        nameLabel = new javax.swing.JLabel();
	        nameText = new javax.swing.JTextField();
	        leftPanel = new javax.swing.JPanel();
	        areaPanel = new javax.swing.JPanel();
	        areaCheckBox = new javax.swing.JCheckBox();
	        resizePanel = new javax.swing.JPanel();
	        resizeButton = new javax.swing.JButton();

	        setLayout(new java.awt.GridLayout(1, 0));

	        setPreferredSize(new java.awt.Dimension(200, 42));
	        namePanel.setLayout(new java.awt.GridBagLayout());

	        namePanel.setPreferredSize(new java.awt.Dimension(100, 42));
	        nameLabel.setText("jLabel1");
	        gridBagConstraints = new java.awt.GridBagConstraints();
	        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
	        gridBagConstraints.weightx = 1.0;
	        gridBagConstraints.insets = new java.awt.Insets(2, 5, 2, 5);
	        namePanel.add(nameLabel, gridBagConstraints);

	        nameText.setText("jTextField1");
	        gridBagConstraints = new java.awt.GridBagConstraints();
	        gridBagConstraints.gridx = 0;
	        gridBagConstraints.gridy = 1;
	        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
	        gridBagConstraints.weightx = 1.0;
	        gridBagConstraints.insets = new java.awt.Insets(2, 5, 2, 4);
	        namePanel.add(nameText, gridBagConstraints);

	        add(namePanel);

	        leftPanel.setLayout(new java.awt.GridBagLayout());

	        leftPanel.setPreferredSize(new java.awt.Dimension(100, 40));
	        areaPanel.setLayout(new java.awt.GridBagLayout());

	        areaPanel.setPreferredSize(new java.awt.Dimension(200, 40));
	        areaCheckBox.setText("jCheckBox1");
	        areaCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
	        areaCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
	        areaCheckBox.setPreferredSize(new java.awt.Dimension(90, 30));
	        gridBagConstraints = new java.awt.GridBagConstraints();
	        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
	        gridBagConstraints.weightx = 1.0;
	        gridBagConstraints.insets = new java.awt.Insets(20, 2, 2, 2);
	        areaPanel.add(areaCheckBox, gridBagConstraints);

	        gridBagConstraints = new java.awt.GridBagConstraints();
	        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
	        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
	        gridBagConstraints.weightx = 0.3;
	        leftPanel.add(areaPanel, gridBagConstraints);

	        resizePanel.setLayout(new java.awt.GridBagLayout());

	        resizePanel.setPreferredSize(new java.awt.Dimension(40, 40));
	        resizeButton.setMaximumSize(null);
	        resizeButton.setMinimumSize(null);
	        resizeButton.setOpaque(false);
	        resizeButton.setPreferredSize(new java.awt.Dimension(25, 25));
	
	        gridBagConstraints = new java.awt.GridBagConstraints();
	        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
	        gridBagConstraints.insets = new java.awt.Insets(19, 2, 2, 2);
	        resizePanel.add(resizeButton, gridBagConstraints);

	        gridBagConstraints = new java.awt.GridBagConstraints();
	        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
	        gridBagConstraints.weightx = 0.7;
	        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 2);
	        leftPanel.add(resizePanel, gridBagConstraints);

	        add(leftPanel);
	}// </editor-fold> 

	/**
	 * Rewrite the labels
	 */
	private void initLabels(){
		nameText.setText("");
		nameLabel.setText(Messages.getText("name"));
		areaCheckBox.setText(Messages.getText("restrictArea"));
		resizeButton.setSize(new Dimension(CatalogConstants.RESIZE_WINDOW_BUTTON_SIZE, 
				CatalogConstants.RESIZE_WINDOW_BUTTON_SIZE));
		setDownIcon();
	}

	/**
	 * Add a listener for the buttons
	 * @param listener
	 * Listener to add
	 */
	public void addActionListener(ActionListener listener){
		resizeButton.addActionListener(listener);
		resizeButton.setActionCommand("resize");
	}

	/**
	 * Sets the up triangle icon (to minimize)
	 */
	public void setUpIcon() {        
		resizeButton.setIcon(new ImageIcon("./gvSIG/extensiones/es.gva.cit.gvsig.catalogClient/images/up.png"));
	} 

	/**
	 * Sets the down triangle icon (to maximize)
	 */
	public void setDownIcon() {        
		resizeButton.setIcon(new ImageIcon("./gvSIG/extensiones/es.gva.cit.gvsig.catalogClient/images/down.png"));
	} 
	
	/**
	 * @return if the are check is clicked
	 */
    public boolean isRestrictAreaClicked() {        
        return areaCheckBox.isSelected();
    } 
    
    /**
     * @return the geoname 
     */
    public String getName(){
    	return nameText.getText();
    }
}
