/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.project.documents.view.toolListeners;

import java.awt.geom.Point2D;
import java.text.NumberFormat;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiFrame.MainFrame;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.tools.AreaListenerImpl;
import com.iver.cit.gvsig.fmap.tools.Events.MeasureEvent;


/**
 * DOCUMENT ME!
 *
 * @author Vicente Caballero Navarro
 */
public class AreaListener extends AreaListenerImpl {
	/**
     * Crea un nuevo AreaListener.
     *
     * @param vp DOCUMENT ME!
     */
    public AreaListener(MapControl mc) {
    	super(mc);
    }

    /**
     * DOCUMENT ME!
     *
     * @param event DOCUMENT ME!
     */
    public void points(MeasureEvent event) {
        this.event = event;

        double dist = 0;
        double distAll = 0;

        ViewPort vp = mapCtrl.getMapContext().getViewPort();
        for (int i = 0; i < (event.getXs().length - 1); i++) {
            dist = 0;

            Point2D p = new Point2D.Double(event.getXs()[i].doubleValue(), event.getYs()[i].doubleValue());//vp.toMapPoint(new Point(event.getXs()[i].intValue(), event.getYs()[i].intValue()));
            Point2D p2 = new Point2D.Double(event.getXs()[i + 1].doubleValue(), event.getYs()[i + 1].doubleValue());//vp.toMapPoint(new Point(event.getXs()[i + 1].intValue(), event.getYs()[i + 1].intValue()));
            ///dist = vp.toMapDistance((int) p.distance(p2));
            dist = vp.distanceWorld(p,p2);
            System.out.println("distancia parcial = "+dist);
            distAll += dist;
        }

       // System.out.println("Permetro = " + distAll + " rea = " +
       //     (returnArea(vp.toMapPoint(
       //             new Point2D.Double(
       //                 event.getXs()[event.getXs().length - 2].doubleValue(),
       //                 event.getYs()[event.getYs().length - 2].doubleValue())))));
        NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(2);
        MainFrame mF = PluginServices.getMainFrame();
        if (mF != null)
        {
        	int distanceUnits=mapCtrl.getViewPort().getDistanceUnits();
            mF.getStatusBar().setMessage("4",
        			"P:" + nf.format(distAll/MapContext.CHANGEM[distanceUnits]) + "");
        		mF.getStatusBar().setMessage("5",
        			///"A:" + nf.format(returnArea(vp.toMapPoint(
                    ///        new Point2D.Double(
                    ///                event.getXs()[event.getXs().length - 2].doubleValue(),
                    ///                event.getYs()[event.getYs().length - 2].doubleValue())))/FMap.CHANGEM[mapCtrl.getViewPort().getDistanceUnits()]) + "");
        				"A:" + nf.format(returnArea(
                                new Point2D.Double(
                                        event.getXs()[event.getXs().length - 2].doubleValue(),
                                        event.getYs()[event.getYs().length - 2].doubleValue()))/Math.pow(MapContext.CHANGEM[distanceUnits],2)) + "");
        }
    }


}
