/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.project.documents.view.toolListeners;

import java.awt.geom.Point2D;
import java.text.NumberFormat;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.tools.MeasureListenerImpl;
import com.iver.cit.gvsig.fmap.tools.Events.MeasureEvent;


/**
 * DOCUMENT ME!
 *
 * @author Vicente Caballero Navarro
 */
public class MeasureListener extends MeasureListenerImpl {
	/**
	 * DOCUMENT ME!
	 *
	 * @param mc
	 */
	public MeasureListener(MapControl mc) {
		super(mc);
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param event DOCUMENT ME!
	 */
	public void points(MeasureEvent event) {
		double dist = 0;
		double distAll = 0;

		ViewPort vp = mapCtrl.getMapContext().getViewPort();

		Point2D p = new Point2D.Double(event.getXs()[0].doubleValue(),event.getYs()[0].doubleValue());//vp.toMapPoint(new Point(event.getXs()[0].intValue(),event.getYs()[0].intValue()));
		for (int i = 1; i < (event.getXs().length); i++) {
			Point2D p2 = new Point2D.Double(event.getXs()[i].doubleValue(),	event.getYs()[i].doubleValue());// vp.toMapPoint(new Point(event.getXs()[i].intValue(),event.getYs()[i].intValue()));
			dist = vp.distanceWorld(p, p2);
			distAll += dist;
			p = p2;
		}

		//System.out.println("Distancia = " + dist + " Distancia Total = " +
		//	(distAll));
		NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(2);
        if (PluginServices.getMainFrame() != null)
        {
            PluginServices.getMainFrame().getStatusBar().setMessage("4",
    			"Dist:" + nf.format(dist/MapContext.CHANGEM[mapCtrl.getViewPort().getDistanceUnits()]) + "");
    		PluginServices.getMainFrame().getStatusBar().setMessage("5",
    			"Total:" + nf.format(distAll/MapContext.CHANGEM[mapCtrl.getViewPort().getDistanceUnits()]) + "");
        }
	}
}
