/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 */
package es.prodevelop.cit.gvsig.arcims.fmap.drivers;

import com.hardcode.driverManager.DriverLoadException;

import com.hardcode.gdbms.engine.data.DataSource;

import com.iver.cit.gvsig.fmap.core.IFeature;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.core.ShapeFactory;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.layers.FBitSet;
import com.iver.cit.gvsig.fmap.layers.SelectableDataSource;
import com.iver.cit.gvsig.fmap.layers.VectorialAdapter;

import org.gvsig.remoteClient.arcims.exceptions.ArcImsException;

import java.awt.geom.Rectangle2D;

import java.io.IOException;


public class ArcImsVectorialAdapter extends VectorialAdapter {
    private IFeature[] testArray;

    public ArcImsVectorialAdapter(FMapFeatureArcImsDriver drv) {
        setDriver(drv);
    }

    public IGeometry getShape(int index) throws DriverIOException {
        try {
            return getDriver().getShape(index);
        }
        catch (IOException e) {
            DriverIOException dioe = new DriverIOException(e.getMessage());
            throw dioe;
        }
    }

    public int getShapeCount() throws DriverIOException {
        try {
            return getDriver().getShapeCount();
        }
        catch (IOException e) {
            DriverIOException dioe = new DriverIOException(e.getMessage());
            throw dioe;
        }
    }

    public Rectangle2D getFullExtent() throws DriverIOException {
        try {
            return getDriver().getFullExtent();
        }
        catch (IOException e) {
            DriverIOException dioe = new DriverIOException(e.getMessage());
            throw dioe;
        }
    }

    public int getShapeType() throws DriverIOException {
        return getDriver().getShapeType();
    }

    /**
     * This method is used when the data source is a proper database that needs
     * initialization.
     */
    public void start() throws DriverIOException {
        try {
            ((FMapFeatureArcImsDriver) getDriver()).getRecordSet().start();
        }
        catch (com.hardcode.gdbms.engine.data.driver.DriverException e) {
            DriverIOException dioe = new DriverIOException(e.getMessage());
            throw dioe;
        }
    }

    /**
     * This method is used when the data source is a proper database that needs
     * to be closed after use.
     */
    public void stop() throws DriverIOException {
        try {
            ((FMapFeatureArcImsDriver) driver).getRecordSet().stop();
        }
        catch (com.hardcode.gdbms.engine.data.driver.DriverException e) {
            DriverIOException dioe = new DriverIOException(e.getMessage());
            throw dioe;
        }
    }

    public SelectableDataSource getRecordset() throws DriverLoadException {
        return ((FMapFeatureArcImsDriver) driver).getRecordSet();
    }

    public void requestFeatureAttributes(FBitSet fbs) throws ArcImsException {
        ((FMapFeatureArcImsDriver) driver).requestFeatureAttributes(fbs);
    }
}
