package com.iver.cit.gvsig.project.documents.table.operators;

import java.awt.geom.Point2D;
import java.util.ArrayList;

import org.apache.bsf.BSFException;
import org.apache.bsf.BSFManager;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.ExpresionFieldExtension;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.core.FShape;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.layers.ReadableVectorial;
import com.iver.cit.gvsig.project.documents.table.GraphicOperator;
import com.iver.cit.gvsig.project.documents.table.IOperator;
import com.iver.cit.gvsig.project.documents.table.Index;
/**
 * @author Vicente Caballero Navarro
 */
public class Perimeter extends GraphicOperator{

	public String addText(String s) {
		return s.concat(toString()+"()");
	}
	public double process(Index index) throws DriverIOException {
		ReadableVectorial adapter = getLayer().getSource();
	   	IGeometry geom=adapter.getShape(index.get());
	   	ArrayList parts=getXY(geom);
	   	double perimeter=0;
	   	for (int j=0;j<parts.size();j++){
	   	Double[][] xsys=(Double[][])parts.get(j);//getXY(geom);
	    double dist = 0;
        double distAll = 0;

        ViewPort vp = getLayer().getMapContext().getViewPort();
        for (int i = 0; i < (xsys[0].length - 1); i++) {
            dist = 0;

            Point2D p = new Point2D.Double(xsys[0][i].doubleValue(), xsys[1][i].doubleValue());//vp.toMapPoint(new Point(event.getXs()[i].intValue(), event.getYs()[i].intValue()));
            Point2D p2 = new Point2D.Double(xsys[0][i + 1].doubleValue(), xsys[1][i + 1].doubleValue());//vp.toMapPoint(new Point(event.getXs()[i + 1].intValue(), event.getYs()[i + 1].intValue()));
            dist = vp.distanceWorld(p,p2);
            //System.out.println("distancia parcial = "+dist);
            distAll += dist;
        }
        int distanceUnits=vp.getDistanceUnits();
		perimeter+= distAll/MapContext.CHANGEM[distanceUnits];
	   	}
	   	return perimeter;
	}
	public void eval(BSFManager interpreter) throws BSFException {
		interpreter.declareBean("jperimeter",this,Perimeter.class);
//		interpreter.eval(ExpresionFieldExtension.BEANSHELL,null,-1,-1,"double perimeter(){return jperimeter.process(indexRow);};");
		interpreter.exec(ExpresionFieldExtension.JYTHON,null,-1,-1,"def perimeter():\n" +
				"  return jperimeter.process(indexRow)");
	}
	public String toString() {
		return "perimeter";
	}
	public boolean isEnable() {
		if (getLayer()==null)
			return false;
		ReadableVectorial adapter = getLayer().getSource();
		int type=FShape.POINT;
		try {
			type=adapter.getShapeType();
		} catch (DriverIOException e) {
			e.printStackTrace();
		}
		return (getType()==IOperator.NUMBER && (type==FShape.POLYGON || type==FShape.LINE));
	}
	public String getTooltip(){
		return PluginServices.getText(this,"operator")+":  "+addText("")+"\n"+getDescription();
	}
	public String getDescription() {
        return PluginServices.getText(this, "returns") + ": " +
        PluginServices.getText(this, "numeric_value") + "\n" +
        PluginServices.getText(this, "description") + ": " +
        "Returns the perimeter of polygon or line geometry  of this row.";
    }
}
