package org.gvsig.rasterTools.saveRaster.ui.main;

import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JPanel;

import org.gvsig.rasterTools.saveRaster.ui.listener.MethodDataInputListener;



public class MethodDataInputPanel extends JPanel {

	private JPanel 							pNorth = null;
	private InputSizeDataPanel				pSouth = null;
	private MethodSaveRasterSelectorPanel	pWest = null;
	private InputScaleDataPanel 			pEast = null;
	private MethodDataInputListener			listener = null;

	/**
	 * This is the default constructor
	 */
	public MethodDataInputPanel() {
		super();
		initialize();
		listener = new MethodDataInputListener(this);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.insets = new java.awt.Insets(0,0,0,0);
		gridBagConstraints1.gridy = 1;
		gridBagConstraints1.gridx = 0;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.insets = new java.awt.Insets(0,0,0,0);
		gridBagConstraints.gridy = 0;
		gridBagConstraints.gridx = 0;
		this.setLayout(new GridBagLayout());
		this.setSize(337, 122);
		this.setPreferredSize(new java.awt.Dimension(337,122));
		this.add(getPNorth(), gridBagConstraints);
		this.add(getPSouth(), gridBagConstraints1);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPNorth() {
		if (pNorth == null) {
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 1;
			gridBagConstraints3.insets = new java.awt.Insets(0,8,0,0);
			gridBagConstraints3.gridy = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.insets = new java.awt.Insets(0,0,0,8);
			gridBagConstraints2.gridy = 0;
			pNorth = new JPanel();
			pNorth.setLayout(new GridBagLayout());
			pNorth.add(getPWest(), gridBagConstraints2);
			pNorth.add(getPEast(), gridBagConstraints3);
		}
		return pNorth;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPSouth() {
		if (pSouth == null) {
			pSouth = new InputSizeDataPanel();
			pSouth.setPreferredSize(new java.awt.Dimension(337,30));
		}
		return pSouth;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPWest() {
		if (pWest == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setVgap(5);
			pWest = new MethodSaveRasterSelectorPanel();
			pWest.setLayout(flowLayout1);
			pWest.setPreferredSize(new java.awt.Dimension(122,92));
		}
		return pWest;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPEast() {
		if (pEast == null) {
			pEast = new InputScaleDataPanel();
			pEast.setPreferredSize(new java.awt.Dimension(180,92));
		}
		return pEast;
	}

}
