package org.gvsig.rasterTools.saveRaster.ui.main;

import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

public class MethodSaveRasterSelectorPanel extends JPanel {

	private JPanel 			pMethodSelector = null;
	private JRadioButton 	rbScale = null;
	private JRadioButton 	rbMtsPixel = null;
	private JRadioButton 	rbSize = null;
	private ButtonGroup 	group = null;

	/**
	 * This is the default constructor
	 */
	public MethodSaveRasterSelectorPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		FlowLayout flowLayout = new FlowLayout();
		flowLayout.setHgap(2);
		flowLayout.setVgap(2);
		this.setLayout(flowLayout);
		this.setSize(98, 73);
		this.setPreferredSize(new java.awt.Dimension(98,73));
		group = new ButtonGroup();
		this.add(getPMethodSelector(), null);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPMethodSelector() {
		if (pMethodSelector == null) {
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints2.gridy = 2;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints1.gridy = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints.gridy = 1;
			pMethodSelector = new JPanel();
			pMethodSelector.setLayout(new GridBagLayout());
			pMethodSelector.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pMethodSelector.setPreferredSize(new java.awt.Dimension(105,77));
			group.add(getRbScale());
			group.add(getRbMtsPixel());
			group.add(getRbSize());
			pMethodSelector.add(getRbScale(), gridBagConstraints1);
			pMethodSelector.add(getRbMtsPixel(), gridBagConstraints);
			pMethodSelector.add(getRbSize(), gridBagConstraints2);
		}
		return pMethodSelector;
	}

	/**
	 * This method initializes jRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	public JRadioButton getRbScale() {
		if (rbScale == null) {
			rbScale = new JRadioButton();
			rbScale.setText("Escala");
			rbScale.setSelected(true);
		}
		return rbScale;
	}

	/**
	 * This method initializes jRadioButton1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	public JRadioButton getRbMtsPixel() {
		if (rbMtsPixel == null) {
			rbMtsPixel = new JRadioButton();
			rbMtsPixel.setText("Mts/Pixel");
		}
		return rbMtsPixel;
	}

	/**
	 * This method initializes jRadioButton2	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	public JRadioButton getRbSize() {
		if (rbSize == null) {
			rbSize = new JRadioButton();
			rbSize.setText("Tamao");
		}
		return rbSize;
	}

}
