package org.cresques.filter.bands;

public class RasterFloatToImageFilter extends RasterToImageFilter {

	private float[] 		px = {0, 0, 0, 255};
	 
    /**
     * Constructor
     *
     */
    public RasterFloatToImageFilter() {
    }

    /* (non-Javadoc)
     * @see org.cresques.io.raster.IRasterFilter#pre()
     */
    public void pre() {
       super.pre();
    }

    /* (non-Javadoc)
     * @see org.cresques.px.PxRaster.RasterFilter#process(int, int)
     */
    public void process(int col, int line) {
        raster.getElemFloat(line, col, px);
        rgb = (alpha & ((((int)255) & 0xff) << 24)) | ((Math.round(px[0]) & 0xff) << 16) |
              ((Math.round(px[1]) & 0xff) << 8) | (Math.round(px[2]) & 0xff);
        /*rgb = (alpha & ((Math.round(px[3]) & 0xff) << 24)) | ((Math.round(px[0]) & 0xff) << 16) |
        ((Math.round(px[1]) & 0xff) << 8) | (Math.round(px[2]) & 0xff);*/

        image.setRGB(col, line, rgb);
    }
    
	public void processSuperSampling(int col, int line){
		raster.getElemFloat(line, col, px);
        rgb = (alpha & ((((int)255) & 0xff) << 24)) | ((Math.round(px[0]) & 0xff) << 16) |
              ((Math.round(px[1]) & 0xff) << 8) | (Math.round(px[2]) & 0xff);
        /*rgb = (alpha & ((Math.round(px[3]) & 0xff) << 24)) | ((Math.round(px[0]) & 0xff) << 16) |
        ((Math.round(px[1]) & 0xff) << 8) | (Math.round(px[2]) & 0xff);*/
        
        for(int j = col; j < raster.getWidth() && j < (col + stepX[contX + 1]); j++)
			for(int i = line; i < raster.getHeight() && i < (line + stepY[contY + 1]); i++)
				image.setRGB(j, i, rgb);
	}

    /* (non-Javadoc)
     * @see org.cresques.io.raster.IRasterFilter#getResult(java.lang.String)
     */
    public Object getResult(String name) {
        return super.getResult(name);
    }

    /* (non-Javadoc)
     * @see org.cresques.px.PxRaster.RasterFilter#processLines(int)
     */
    public void processLine(int y) {
        for (int x = 0; x < width; x++) {
            float[][] line = raster.getLineFloat(y);
            rgb = (alpha & ((Math.round(px[3]) & 0xff) << 24)) |
                  ((Math.round(line[x][0]) & 0xff) << 16) | ((Math.round(line[x][1]) & 0xff) << 8) |
                  (Math.round(line[x][2]) & 0xff);

            image.setRGB(x, y, rgb);
        }
    }

    /* (non-Javadoc)
     * @see org.cresques.io.raster.IRasterFilter#getInRasterDataType()
     */
    public int getInRasterDataType() {
        return super.getInRasterDataType();
    }

    /* (non-Javadoc)
     * @see org.cresques.io.raster.IRasterFilter#getOutRasterDataType()
     */
    public int getOutRasterDataType() {
        return super.getOutRasterDataType();
    }

    /* (non-Javadoc)
     * @see org.cresques.io.raster.IRasterFilter#post()
     */
    public void post() {
    	super.post();
    }

}
