/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*/

package org.cresques.filter.convolution;

import java.awt.Image;

import org.cresques.filter.RasterFilter;
import org.cresques.io.data.RasterBuf;
import org.gvsig.i18n.Messages;

/**
 * Clase base para los filtros de convolucin.
 * 
 * @author Diego Guerrero Sevilla  <diego.guerrero@uclm.es>
 *
 */

public abstract class ConvolutionFilter extends RasterFilter {
	protected Kernel kernel = null;
	protected int umbral = 0;
	protected Image  imageResult = null;
	protected RasterBuf rasterResult = null;
	
	public ConvolutionFilter() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * Constructor para la asignacin del identificador del filtro
	 * @param fName Cadena que representa el identificador del filtro 
	 */
	public ConvolutionFilter(String fName) {
		super();
		super.filterName = fName;
	}

	public void post() {
		// TODO Auto-generated method stub	
	}

	public void pre() {
		kernel = (Kernel) params.get("kernel");
		if (params.get("umbral")!=null)
			umbral = ((Integer)params.get("umbral")).intValue();
		else this.umbral = 0;
	}

	/**
	 * Obtiene el kernel
	 * @return kernel asociado al filtro
	 */
	public Kernel getKernel() {
		return kernel;
	}
}
