package org.cresques.filter.enhancement;

import java.awt.Image;
import java.awt.image.BufferedImage;

import org.cresques.io.data.RasterBuf;


/**
 * 
 * @author Miguel Ángel Querol Carratalá <querol_mig@gva.es>
 *
 */
public class BrightnessShortFilter extends BrightnessFilter{
	private short[] 		px = new short[4];
	
	public BrightnessShortFilter(){
		super();
	}
	
	public void pre(){
		exec = true;
		this.raster = (RasterBuf) params.get("raster");
		height = raster.getHeight();
        width = raster.getWidth();
		this.incrBrillo = ((Integer) params.get("incrBrillo")).intValue();
		
		super.pre();
	}
	
	

	public void process(int col, int line) {
		raster.getElemShort(line, col, px);
		
		for(int i = 0 ; i < 3 ; i++){
			if((px[i] + incrBrillo) > 255)
				px[i] = 255;
			else if((px[i] + incrBrillo) < 0)
				px[i] = 0;
			else
				px[i] += incrBrillo;
		}
		
		raster.setElemShort(line, col, px);
	}

	 /* (non-Javadoc)
     * @see org.cresques.io.raster.IRasterFilter#processSuperSampling(int, int)
     */
	public void processSuperSampling(int col, int line) {
		raster.getElemShort(line, col, px);
		
		for(int i = 0 ; i < 3 ; i++){
			if((px[i] + incrBrillo) > 255)
				px[i] = 255;
			else if((px[i] + incrBrillo) < 0)
				px[i] = 0;
			else
				px[i] += incrBrillo;
		}
		
        for(int j = col; j < raster.getWidth() && j < (col + stepX[contX + 1]); j++)
			for(int i = line; i < raster.getHeight() && i < (line + stepY[contY + 1]); i++)
				 raster.setElemShort(i, j, px);
			
	}
	
	public void processLine(int y) {
		// TODO Auto-generated method stub
		
	}

	public int getInRasterDataType() {
		return RasterBuf.TYPE_SHORT;
	}

	public int getOutRasterDataType() {
		return RasterBuf.TYPE_SHORT;
	}

	public Object getResult(String name) {
		if (name.equals("raster")) {
            return (Object) this.raster;
        } else {
            return null;
        }
	}
	
}
