/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.filter.statistics;

import org.cresques.io.data.RasterBuf;

/**
 * Proceso del filtro de recorte de colas aplicado a imgenes 32 bits
 * 
 * @author Nacho Brodin (brodin_ign@gva.es)
 *
 */
public class PercentTailTrimIntegerFilter extends PercentTailTrimFilter {

	private int[] 		px = new int[4];
	
	public void process(int col, int line) {
		raster.getElemInt(line, col, px);
        sample[0][count] = px[0];
        sample[1][count] = px[1];
        sample[2][count] = px[2];
        count++;
	}

	public void processSuperSampling(int col, int line) {
		process(col, line);	

	}

	public void processLine(int y) {
		// TODO Auto-generated method stub

	}

	public int getInRasterDataType() {
		return RasterBuf.TYPE_INT;
	}

	public int getOutRasterDataType() {
		return RasterBuf.TYPE_INT;
	}

	public void post() {
		super.post();
	}

	public void pre() {
		 //Obtencin de parmetros
        this.raster = (RasterBuf) params.get("raster");
        height = raster.getHeight();
        width = raster.getWidth();
        super.pre();
	}

}
