package com.iver.cit.gvsig.fmap.edition.commands;

import java.io.IOException;

import com.iver.cit.gvsig.fmap.core.IRow;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.edition.EditionEvent;
import com.iver.cit.gvsig.fmap.edition.IEditableSource;

public class ModifyRowCommand extends AbstractCommand {

	private IEditableSource efs;
	private IRow rowNext;
	private int calculatedIndexAnt;
	private int previousIndexInExpansionFile;
	private int type=EditionEvent.GRAPHIC;
	/**
	 * @param ef IEditableSource
	 * @param calculatedIndex index of modified row
	 * @param p previous index in expansion file. -1 if previous is from original data source.
	 * @param newRow
	 * @throws IOException
	 * @throws DriverIOException
	 */
	public ModifyRowCommand(IEditableSource ef,int calculatedIndex,int previousInExpansionFile,IRow newRow,int type) throws IOException, DriverIOException{
		super();
		efs=ef;
		calculatedIndexAnt=calculatedIndex;
		rowNext=newRow;
		previousIndexInExpansionFile=previousInExpansionFile;
		this.type=type;
	}
	/**
	 * @throws DriverIOException
	 * @throws IOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#undo()
	 */
	public void undo() throws IOException, DriverIOException {
		efs.undoModifyRow(calculatedIndexAnt,previousIndexInExpansionFile,type);
	}
	/**
	 * @throws DriverIOException
	 * @throws IOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#redo()
	 */
	public void redo() throws IOException, DriverIOException {
		efs.doModifyRow(calculatedIndexAnt,rowNext,type);
		}
	public String getType() {
		return "Modify";
	}
}
