package com.iver.cit.gvsig.fmap.edition.commands;

import java.io.IOException;

import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.edition.EditionEvent;
import com.iver.cit.gvsig.fmap.edition.IEditableSource;

public class RemoveRowCommand extends AbstractCommand {

	private IEditableSource efs;
	private int index;
	private int sourceType=EditionEvent.GRAPHIC;
	public RemoveRowCommand(IEditableSource ef,int i,int sourceType) throws DriverIOException, IOException{
		super();
		efs=ef;
		index=i;
		this.sourceType=sourceType;
	}

	/**
	 * @throws DriverIOException
	 * @throws IOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#undo()
	 */
	public void undo() throws IOException, DriverIOException {
		efs.undoRemoveRow(index,sourceType);
	}
	/**
	 * @throws IOException
	 * @throws DriverIOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#redo()
	 */
	public void redo() throws DriverIOException, IOException {
		efs.doRemoveRow(index,sourceType);
	}

	public String getType() {
		return "Remove";
	}
}
