package com.iver.cit.gvsig.fmap.edition.writers.gdbms;

import java.sql.Types;

import com.hardcode.gdbms.engine.data.driver.DriverException;
import com.hardcode.gdbms.engine.data.edition.DataWare;
import com.hardcode.gdbms.engine.values.Value;
import com.iver.cit.gvsig.fmap.core.IRow;
import com.iver.cit.gvsig.fmap.drivers.ITableDefinition;
import com.iver.cit.gvsig.fmap.edition.EditionException;
import com.iver.cit.gvsig.fmap.edition.IRowEdited;
import com.iver.cit.gvsig.fmap.edition.writers.AbstractWriter;

public class GdbmsWriter extends AbstractWriter {
	DataWare dataWare;
	Value[] record;
	int numRecord;

	public GdbmsWriter(){
	}
	public void initialize(ITableDefinition tableDef){
	}
	public void setDataWare(DataWare dataWare)
	{
		this.dataWare = dataWare;
	}
	public void preProcess() throws EditionException {
		try {
			dataWare.beginTrans();
			numRecord = 0;
		} catch (com.hardcode.gdbms.engine.data.driver.DriverException e) {
			throw new EditionException(e);
		}
	}

	public void process(IRowEdited editedRow) throws EditionException {
		IRow row = (IRow) editedRow.getLinkedRow();

		try {
			/* System.out.println("Intento escribir el registro " +
					numRows + " de la capa " + lyrVect.getName()); */


			switch (editedRow.getStatus())
			{
    		case IRowEdited.STATUS_ADDED:
    			record=row.getAttributes();
    				//record[i] = row.getAttribute(i);
    			dataWare.insertFilledRow(record);
    			break;
    		case IRowEdited.STATUS_MODIFIED:
    			record=row.getAttributes();
    			for (int i=0; i < record.length; i++)
    				dataWare.setFieldValue(numRecord, i, record[i]);
    			break;
    		case IRowEdited.STATUS_ORIGINAL:
    			break;
    		case IRowEdited.STATUS_DELETED:
        		dataWare.deleteRow(numRecord);
    			break;
			}
			numRecord++;

		} catch (DriverException e) {
			throw new EditionException(e);
		}

	}

	public void postProcess() throws EditionException {
		try {
			dataWare.commitTrans();

		} catch (DriverException e) {
			try {
				dataWare.rollBackTrans();
			} catch (DriverException e1) {
				throw new EditionException(e1);
			}
			throw new EditionException(e);
		}
	}


	public String getName() {
		return "GDBMS Writer";
	}

	public boolean canWriteGeometry(int gvSIGgeometryType) {
		return false;
	}

	public boolean canWriteAttribute(int sqlType) {
		switch (sqlType)
		{
		case Types.DOUBLE:
		case Types.FLOAT:
		case Types.INTEGER:
		case Types.BIGINT:
			return true;
		case Types.DATE:
			return true;
		case Types.BIT:
		case Types.BOOLEAN:
			return true;
		case Types.VARCHAR:
		case Types.CHAR:
		case Types.LONGVARCHAR:
			return true; // TODO: Revisar esto, porque no creo que admita campos muy grandes

		}

		return false;
	}
	public boolean canAlterTable() {
		// TODO Auto-generated method stub
		return false;
	}
	public boolean canSaveEdits() {
		return false;
	}


}
