package com.hardcode.gdbms.engine.data;

import com.hardcode.gdbms.engine.data.driver.DriverException;
import com.hardcode.gdbms.engine.values.Value;

/**
 * @author Fernando Gonzlez Corts
 */
public abstract class DataSourceCommonImpl implements DataSource{

	/**
	 * @see com.hardcode.gdbms.engine.data.DataSource#getRow(long)
	 */
	public Value[] getRow(long rowIndex) throws DriverException {
		Value[] ret = new Value[getFieldCount()];

		for (int i = 0; i < ret.length; i++) {
			ret[i] = getFieldValue(rowIndex, i);
		}

		return ret;
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.DataSource#getFieldNames()
	 */
	public String[] getFieldNames() throws DriverException {
		String[] ret = new String[getFieldCount()];

		for (int i = 0; i < ret.length; i++) {
			ret[i] = getFieldName(i);
		}

		return ret;
	}

    /**
     * gets a string representation of this datasource
     *
     * @return String
     *
     * @throws DriverException
     */
    public String getAsString() throws DriverException {
    
        StringBuffer aux = new StringBuffer();
        int fc = getFieldCount();
        int rc = (int) getRowCount();
    
        for (int i = 0; i < fc; i++) {
            aux.append(getFieldName(i).toUpperCase()).append("\t");
        }
    
        for (int row = 0; row < rc; row++) {
            for (int j = 0; j < fc; j++) {
                aux.append(getFieldValue(row, j)).append("\t");
            }
        }
    
        return aux.toString();
    }

}
