package org.gvsig.gpe.gml.parser.profiles;


import org.gvsig.gpe.gml.parser.v2.features.ElementTypeBinding;
import org.gvsig.gpe.gml.parser.v2.features.FeatureCollectionBinding;
import org.gvsig.gpe.gml.parser.v2.features.FeatureMemberTypeBinding;
import org.gvsig.gpe.gml.parser.v2.features.FeatureTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.BoundedByTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.BoxTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.CoordTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.CoordinatesTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.GeometryBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.GeometryMemberTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.GeometryPropertyTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.InnerBoundaryIsTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.LineStringMemberTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.LineStringPropertyTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.LineStringTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.LinearRingTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.MultiGeometryPropertyTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.MultiGeometryTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.MultiLineStringPropertyTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.MultiLineStringTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.MultiPointPropertyTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.MultiPointTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.MultiPolygonPropertyTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.MultiPolygonTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.OuterBoundaryIsTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.PointMemberTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.PointPropertyTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.PointTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.PolygonMemberTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.PolygonPropertyTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.PolygonTypeBinding;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id$
 * $Log$
 *
 */
/**
 * @author Jorge Piera LLodr (jorge.piera@iver.es)
 */
public class Gml2BindingProfile extends DefaultBindingProfile {
	protected FeatureCollectionBinding featureCollectionBinding = null;
	protected ElementTypeBinding elementTypeBinding = null;
	protected GeometryBinding geometryBinding = null;
	protected GeometryPropertyTypeBinding geometryPropertyTypeBinding = null;
	protected PointPropertyTypeBinding pointPropertyTypeBinding = null;
	protected LineStringPropertyTypeBinding lineStringPropertyTypeBinding = null;
	protected PolygonPropertyTypeBinding polygonPropertyTypeBinding = null;
	protected MultiPointPropertyTypeBinding multiPointPropertyTypeBinding = null;
	protected MultiLineStringPropertyTypeBinding multiLineStringPropertyTypeBinding = null;
	protected MultiPolygonPropertyTypeBinding multiPolygonPropertyTypeBinding = null;
	protected MultiGeometryPropertyTypeBinding multiGeometryPropertyTypeBinding = null;
	protected BoundedByTypeBinding boundedByTypeBinding = null;
	protected FeatureMemberTypeBinding featureMemberTypeBinding = null;
	protected FeatureTypeBinding featureTypeBinding = null;
	protected BoxTypeBinding boxTypeBinding = null;
	protected CoordinatesTypeBinding coordinatesTypeBinding = null;
	protected CoordTypeBinding coordTypeBinding = null;
	protected PointMemberTypeBinding pointMemberTypeBinding = null;
	protected PointTypeBinding pointTypeBinding = null;
	protected LineStringMemberTypeBinding lineStringMemberTypeBinding = null;
	protected LineStringTypeBinding lineStringTypeBinding = null;
	protected LinearRingTypeBinding linearRingTypeBinding = null;
	protected PolygonMemberTypeBinding polygonMemberTypeBinding = null;
	protected PolygonTypeBinding polygonTypeBinding = null;
	protected GeometryMemberTypeBinding geometryMemberTypeBinding = null;
	protected MultiPointTypeBinding multiPointTypeBinding = null;
	protected MultiLineStringTypeBinding multiLineStringTypeBinding = null;
	protected MultiPolygonTypeBinding multiPolygonTypeBinding = null;
	protected MultiGeometryTypeBinding multiGeometryTypeBinding = null;
	protected OuterBoundaryIsTypeBinding outerBoundaryIsTypeBinding = null;
	protected InnerBoundaryIsTypeBinding innerBoundaryIsTypeBinding = null;
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getFeatureCollectionBinding()
	 */
	public FeatureCollectionBinding getFeatureCollectionBinding(){
		if (featureCollectionBinding == null){
			featureCollectionBinding = new FeatureCollectionBinding();
		}
		return featureCollectionBinding;
	}
		
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getElementTypeBinding()
	 */
	public ElementTypeBinding getElementTypeBinding(){
		if (elementTypeBinding == null){
			elementTypeBinding = new ElementTypeBinding();
		}
		return elementTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getGeometryBinding()
	 */
	public GeometryBinding getGeometryBinding() {
		if (geometryBinding == null){
			geometryBinding = new GeometryBinding();
		}
		return geometryBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getGeometryPropertyTypeBinding()
	 */
	public GeometryPropertyTypeBinding getGeometryPropertyTypeBinding() {
		if (geometryPropertyTypeBinding == null){
			geometryPropertyTypeBinding = new GeometryPropertyTypeBinding();
		}
		return geometryPropertyTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getLineStringPropertyTypeBinding()
	 */
	public LineStringPropertyTypeBinding getLineStringPropertyTypeBinding() {
		if (lineStringPropertyTypeBinding == null){
			 lineStringPropertyTypeBinding = new LineStringPropertyTypeBinding();
		}
		return lineStringPropertyTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getMultiGeometryPropertyTypeBinding()
	 */
	public MultiGeometryPropertyTypeBinding getMultiGeometryPropertyTypeBinding() {
		if (multiGeometryPropertyTypeBinding== null){
			multiGeometryPropertyTypeBinding = new MultiGeometryPropertyTypeBinding();
		}
		return multiGeometryPropertyTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getMultiLineStringPropertyTypeBinding()
	 */
	public MultiLineStringPropertyTypeBinding getMultiLineStringPropertyTypeBinding() {
		if (multiLineStringPropertyTypeBinding== null){
			multiLineStringPropertyTypeBinding = new MultiLineStringPropertyTypeBinding();
		}
		return multiLineStringPropertyTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getMultiPointPropertyTypeBinding()
	 */
	public MultiPointPropertyTypeBinding getMultiPointPropertyTypeBinding() {
		if (multiPointPropertyTypeBinding== null){
			 multiPointPropertyTypeBinding = new MultiPointPropertyTypeBinding();
		}
		return multiPointPropertyTypeBinding ;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getMultiPolygonPropertyTypeBinding()
	 */
	public MultiPolygonPropertyTypeBinding getMultiPolygonPropertyTypeBinding() {
		if (multiPolygonPropertyTypeBinding== null){
			 multiPolygonPropertyTypeBinding =  new MultiPolygonPropertyTypeBinding ();
		}
		return multiPolygonPropertyTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getPointPropertyTypeBinding()
	 */
	public PointPropertyTypeBinding getPointPropertyTypeBinding() {
		if (pointPropertyTypeBinding == null){
			 pointPropertyTypeBinding = new PointPropertyTypeBinding();
		}
		return pointPropertyTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getPolygonPropertyTypeBinding()
	 */
	public PolygonPropertyTypeBinding getPolygonPropertyTypeBinding() {
		if (polygonPropertyTypeBinding == null){
			 polygonPropertyTypeBinding = new PolygonPropertyTypeBinding();
		}
		return polygonPropertyTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getBoundedByTypeBinding()
	 */
	public BoundedByTypeBinding getBoundedByTypeBinding() {
		if (boundedByTypeBinding == null){
			boundedByTypeBinding = new BoundedByTypeBinding();
		}
		return boundedByTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getFeatureMemberTypeBinding()
	 */
	public FeatureMemberTypeBinding getFeatureMemberTypeBinding() {
		if (featureMemberTypeBinding == null){
			featureMemberTypeBinding = new FeatureMemberTypeBinding();
		}
		return featureMemberTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getFeatureTypeBinding()
	 */
	public FeatureTypeBinding getFeatureTypeBinding() {
		if (featureTypeBinding == null){
			featureTypeBinding = new FeatureTypeBinding();
		}
		return featureTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getBoxTypeBinding()
	 */
	public BoxTypeBinding getBoxTypeBinding() {
		if (boxTypeBinding == null){
			boxTypeBinding = new BoxTypeBinding();
		}
		return boxTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getCoordinatesTypeBinding()
	 */
	public CoordinatesTypeBinding getCoordinatesTypeBinding() {
		if (coordinatesTypeBinding == null){
			coordinatesTypeBinding = new CoordinatesTypeBinding();
		}
		return coordinatesTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getCoordTypeBinding()
	 */
	public CoordTypeBinding getCoordTypeBinding() {
		if (coordTypeBinding == null){
			coordTypeBinding = new CoordTypeBinding();
		}
		return coordTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getGeometryMemberTypeBinding()
	 */
	public GeometryMemberTypeBinding getGeometryMemberTypeBinding() {
		if (geometryMemberTypeBinding == null){
			 geometryMemberTypeBinding = new GeometryMemberTypeBinding();
		}
		return geometryMemberTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getLineStringMemberTypeBinding()
	 */
	public LineStringMemberTypeBinding getLineStringMemberTypeBinding() {
		if (lineStringMemberTypeBinding == null){
			 lineStringMemberTypeBinding = new LineStringMemberTypeBinding();
		}
		return lineStringMemberTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getLineStringTypeBinding()
	 */
	public LineStringTypeBinding getLineStringTypeBinding() {
		if (lineStringTypeBinding == null){
			 lineStringTypeBinding = new LineStringTypeBinding();
		}
		return lineStringTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getLinearRingTypeBinding()
	 */
	public LinearRingTypeBinding getLinearRingTypeBinding() {
		if (linearRingTypeBinding == null){
			 linearRingTypeBinding = new LinearRingTypeBinding();
		}
		return linearRingTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getMultiGeometryTypeBinding()
	 */
	public MultiGeometryTypeBinding getMultiGeometryTypeBinding() {
		if (multiGeometryTypeBinding == null){
			 multiGeometryTypeBinding = new MultiGeometryTypeBinding();
		}
		return multiGeometryTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getMultiLineStringTypeBinding()
	 */
	public MultiLineStringTypeBinding getMultiLineStringTypeBinding() {
		if (multiLineStringTypeBinding == null){
			 multiLineStringTypeBinding = new MultiLineStringTypeBinding();
		}
		return multiLineStringTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getMultiPointTypeBinding()
	 */
	public MultiPointTypeBinding getMultiPointTypeBinding() {
		if (multiPointTypeBinding == null){
			 multiPointTypeBinding = new MultiPointTypeBinding();
		}
		return multiPointTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getMultiPolygonTypeBinding()
	 */
	public MultiPolygonTypeBinding getMultiPolygonTypeBinding() {
		if (multiPolygonTypeBinding == null){
			 multiPolygonTypeBinding = new MultiPolygonTypeBinding();
		}
		return multiPolygonTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getPointMemberTypeBinding()
	 */
	public PointMemberTypeBinding getPointMemberTypeBinding() {
		if (pointMemberTypeBinding == null){
			 pointMemberTypeBinding = new PointMemberTypeBinding();
		}
		return pointMemberTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getPointTypeBinding()
	 */
	public PointTypeBinding getPointTypeBinding() {
		if (pointTypeBinding == null){
			 pointTypeBinding = new PointTypeBinding();
		}
		return pointTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getPolygonMemberTypeBinding()
	 */
	public PolygonMemberTypeBinding getPolygonMemberTypeBinding() {
		if (polygonMemberTypeBinding == null){
			 polygonMemberTypeBinding = new PolygonMemberTypeBinding();
		}
		return polygonMemberTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getPolygonTypeBinding()
	 */
	public PolygonTypeBinding getPolygonTypeBinding() {
		if (polygonTypeBinding == null){
			 polygonTypeBinding = new PolygonTypeBinding();
		}
		return polygonTypeBinding;
	}
	
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getOuterBoundaryIsTypeBinding()
	 */
	public OuterBoundaryIsTypeBinding getOuterBoundaryIsTypeBinding() {
		if (outerBoundaryIsTypeBinding == null){
			outerBoundaryIsTypeBinding = new OuterBoundaryIsTypeBinding();
		}
		return outerBoundaryIsTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getInnerBoundaryIsTypeBinding()
	 */
	public InnerBoundaryIsTypeBinding getInnerBoundaryIsTypeBinding() {
		if (innerBoundaryIsTypeBinding == null){
			innerBoundaryIsTypeBinding = new InnerBoundaryIsTypeBinding();
		}
		return innerBoundaryIsTypeBinding;
	}	
}

