package org.gvsig.gpe.gml.parser.profiles;

import org.gvsig.gpe.gml.parser.sfp0.geometries.CurvePropertyTypeBinding;
import org.gvsig.gpe.gml.parser.sfp0.geometries.CurveTypeBinding;
import org.gvsig.gpe.gml.parser.sfp0.geometries.EnvelopeTypeBinding;
import org.gvsig.gpe.gml.parser.sfp0.geometries.ExteriorTypeBinding;
import org.gvsig.gpe.gml.parser.sfp0.geometries.InteriorTypeBinding;
import org.gvsig.gpe.gml.parser.sfp0.geometries.LinestringSegmentTypeBinding;
import org.gvsig.gpe.gml.parser.sfp0.geometries.LowerCornerTypeBinding;
import org.gvsig.gpe.gml.parser.sfp0.geometries.PosListTypeBinding;
import org.gvsig.gpe.gml.parser.sfp0.geometries.PosTypeBinding;
import org.gvsig.gpe.gml.parser.sfp0.geometries.SegmentsTypeBinding;
import org.gvsig.gpe.gml.parser.sfp0.geometries.UpperCornerTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.BoundedByTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.GeometryBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.LineStringTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.LinearRingTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.MultiPolygonTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.PointTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.PolygonMemberTypeBinding;
import org.gvsig.gpe.gml.parser.v2.geometries.PolygonTypeBinding;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id$
 * $Log$
 *
 */
/**
 * @author Jorge Piera LLodr (jorge.piera@iver.es)
 */
public class GmlSFP0BindingProfile extends Gml2BindingProfile{
	protected PosTypeBinding posTypeBinding = null;
	protected EnvelopeTypeBinding envelopeTypeBinding = null;
	protected LowerCornerTypeBinding lowerCornerTypeBinding = null;
	protected UpperCornerTypeBinding upperCornerTypeBinding = null;
	protected CurvePropertyTypeBinding curvePropertyTypeBinding = null;
	protected PosListTypeBinding posListTypeBinding = null;
	protected CurveTypeBinding curveTypeBinding = null;
	protected SegmentsTypeBinding segmentsTypeBinding = null;
	protected LinestringSegmentTypeBinding linestringSegmentTypeBinding = null;
	protected ExteriorTypeBinding exteriorTypeBinding = null;
	protected InteriorTypeBinding interiorTypeBinding = null;
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.DefaultProfile#getPosTypeBinding()
	 */
	public PosTypeBinding getPosTypeBinding() {
		if (posTypeBinding == null){
			posTypeBinding = new PosTypeBinding();
		}
		return posTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getEnvelopeTypeBinding()
	 */
	public EnvelopeTypeBinding getEnvelopeTypeBinding() {
		if (envelopeTypeBinding == null){
			envelopeTypeBinding = new EnvelopeTypeBinding();
		}
		return envelopeTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getLowerCornerTypeBinding()
	 */
	public LowerCornerTypeBinding getLowerCornerTypeBinding() {
		if (lowerCornerTypeBinding == null){
			lowerCornerTypeBinding = new LowerCornerTypeBinding();
		}
		return lowerCornerTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getLowerCornerTypeBinding()
	 */
	public UpperCornerTypeBinding getUpperCornerTypeBinding() {
		if (upperCornerTypeBinding == null){
			upperCornerTypeBinding = new UpperCornerTypeBinding();
		}
		return upperCornerTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.DefaultProfile#getCurvePropertyTypeBinding()
	 */
	public CurvePropertyTypeBinding getCurvePropertyTypeBinding() {
		if (curvePropertyTypeBinding == null){
			curvePropertyTypeBinding = new CurvePropertyTypeBinding();
		}
		return curvePropertyTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getPosListTypeBinding()
	 */
	public PosListTypeBinding getPosListTypeBinding() {
		if (posListTypeBinding == null){
			posListTypeBinding = new PosListTypeBinding();
		}
		return posListTypeBinding;
	}
	

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getCurveTypeBinding()
	 */
	public CurveTypeBinding getCurveTypeBinding() {
		if (curveTypeBinding == null){
			curveTypeBinding = new CurveTypeBinding();
		}
		return curveTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getSegmentsTypeBinding()
	 */
	public SegmentsTypeBinding getSegmentsTypeBinding() {
		if (segmentsTypeBinding == null){
			segmentsTypeBinding = new SegmentsTypeBinding();
		}
		return segmentsTypeBinding;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getLinestringSegmentTypeBinding()
	 */
	public LinestringSegmentTypeBinding getLinestringSegmentTypeBinding() {
		if (linestringSegmentTypeBinding == null){
			linestringSegmentTypeBinding = new LinestringSegmentTypeBinding();
		}
		return linestringSegmentTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getGeometryBinding()
	 */
	public GeometryBinding getGeometryBinding() {
		if (geometryBinding == null){
			geometryBinding = new org.gvsig.gpe.gml.parser.sfp0.geometries.GeometryBinding();
		}
		return geometryBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getBoundedByTypeBinding()
	 */
	public BoundedByTypeBinding getBoundedByTypeBinding() {
		if (boundedByTypeBinding == null){
			boundedByTypeBinding = new org.gvsig.gpe.gml.parser.sfp0.geometries.BoundedByTypeBinding();
		}
		return boundedByTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getPointTypeBinding()
	 */
	public PointTypeBinding getPointTypeBinding() {
		if (pointTypeBinding == null){
			 pointTypeBinding = new org.gvsig.gpe.gml.parser.sfp0.geometries.PointTypeBinding();
		}
		return pointTypeBinding;
	}
	

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.Gml2Profile#getLinearRingTypeBinding()
	 */
	public LinearRingTypeBinding getLinearRingTypeBinding() {
		if (linearRingTypeBinding == null){
			 linearRingTypeBinding = new org.gvsig.gpe.gml.parser.sfp0.geometries.LinearRingTypeBinding();
		}
		return linearRingTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.Gml2Profile#getLineStringTypeBinding()
	*/
	public LineStringTypeBinding getLineStringTypeBinding() {
		if (lineStringTypeBinding == null){
			 lineStringTypeBinding = new org.gvsig.gpe.gml.parser.sfp0.geometries.LineStringTypeBinding();
		}
		return lineStringTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getMultiPolygonTypeBinding()
	 */
	public MultiPolygonTypeBinding getMultiPolygonTypeBinding() {
		if (multiPolygonTypeBinding == null){
			 multiPolygonTypeBinding = new org.gvsig.gpe.gml.parser.sfp0.geometries.MultiPolygonTypeBinding();
		}
		return multiPolygonTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.Gml2Profile#getPolygonMemberTypeBinding()
	 */
	public PolygonMemberTypeBinding getPolygonMemberTypeBinding() {
		if (polygonMemberTypeBinding == null){
			 polygonMemberTypeBinding = new org.gvsig.gpe.gml.parser.sfp0.geometries.PolygonMemberTypeBinding();
		}
		return polygonMemberTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getPolygonTypeBinding()
	 */
	public PolygonTypeBinding getPolygonTypeBinding() {
		if (polygonTypeBinding == null){
			 polygonTypeBinding = new org.gvsig.gpe.gml.parser.sfp0.geometries.PolygonTypeBinding();
		}
		return polygonTypeBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.DefaultProfile#getExteriorTypeBinding()
	 */
	public ExteriorTypeBinding getExteriorTypeBinding() {
		if (exteriorTypeBinding == null){
			exteriorTypeBinding = new ExteriorTypeBinding();
		}
		return exteriorTypeBinding;
	}
	
	/* (non-Javadoc)
	 * @see org.gvsig.gpe.gml.profiles.IProfile#getInteriorTypeBinding()
	 */
	public InteriorTypeBinding getInteriorTypeBinding() {
		if (interiorTypeBinding == null){
			interiorTypeBinding = new InteriorTypeBinding();
		}
		return interiorTypeBinding;
	}
}
