package org.gvsig.gpe.gml.parser.sfp0.geometries;

import java.io.IOException;

import org.gvsig.gpe.gml.GMLTags;
import org.gvsig.gpe.gml.GPEGml2Parser;
import org.gvsig.gpe.gml.utils.CompareUtils;
import org.kxml2.io.KXmlParser;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

public class CurveMemberTypeBinding {

		public static Object parse(XmlPullParser parser,GPEGml2Parser handler) throws XmlPullParserException, IOException {
			boolean endFeature = false;
			int currentTag;
			Object curve = null;		
			
			String tag = parser.getName();
			currentTag = parser.getEventType();

			while (!endFeature){
				switch(currentTag){
				case KXmlParser.START_TAG:
						if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_CURVE)){
							curve = handler.getProfile().getCurveTypeBinding().
							parse(parser, handler);
						}else if (CompareUtils.compareWithOutNamespace(tag, GMLTags.GML_LINESTRING)){
							curve = handler.getContentHandler().startCurve(null, null);
							Object lineString = handler.getProfile().getLineStringTypeBinding().
							parse(parser, handler);
							handler.getContentHandler().addSegmentToCurve(lineString, curve);
						}
						break;
					case KXmlParser.END_TAG:
						if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_CURVEMEMBER)){						
							endFeature = true;						
						}
						break;
					case KXmlParser.TEXT:			
						
						break;
					}
					if (!endFeature){					
						currentTag = parser.next();
						tag = parser.getName();
					}
				}			
			return curve;	
		}
}
