package org.gvsig.gpe.gml.parser.sfp0.geometries;

import java.io.IOException;
import java.util.ArrayList;

import org.gvsig.gpe.gml.GMLTags;
import org.gvsig.gpe.gml.GPEDefaultGmlParser;
import org.gvsig.gpe.gml.parser.v2.geometries.GeometryBinding;
import org.gvsig.gpe.gml.utils.CompareUtils;
import org.gvsig.gpe.gml.utils.CoordsContainer;
import org.kxml2.io.KXmlParser;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

public class CurveTypeBinding extends GeometryBinding{

	public Object parse(XmlPullParser parser,GPEDefaultGmlParser handler) throws XmlPullParserException, IOException {
		boolean endFeature = false;
		int currentTag;
		CoordsContainer coordsContainer = null;
		Object curve = null;

		super.setAtributtes(parser, handler.getErrorHandler());

		String tag = parser.getName();
		currentTag = parser.getEventType();

		while (!endFeature){
			switch(currentTag){
			case KXmlParser.START_TAG:
				if(CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_COORDINATES)){
					double[][] coordinates = handler.getProfile().getCoordinatesTypeBinding().
					parse(parser, handler);
					curve = handler.getContentHandler().startCurve(id,
							coordinates[0],
							coordinates[1],
							coordinates[2],								
							srsName);						
				}else if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_COORD)){
					double[] coordinates = handler.getProfile().getCoordTypeBinding().
					parse(parser, handler);
					if (coordsContainer == null){
						coordsContainer = new CoordsContainer();
					}
					coordsContainer.addCoordinates(coordinates);
				}else if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_SEGMENTS)){
					curve = handler.getContentHandler().startCurve(id, srsName);
					ArrayList segments = handler.getProfile().getSegmentsTypeBinding().
					parse(parser, handler);
					for (int i=0 ; i<segments.size() ; i++){
						handler.getContentHandler().addSegmentToCurve(
								segments.get(i), curve);
					}					
				}
				break;
			case KXmlParser.END_TAG:
				if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_CURVE)){	
					endFeature = true;
					//If the file contains the COORD tag instead of the
					//coordinates
					if (coordsContainer != null){
						double[][] coordinates = coordsContainer.getCoordinates();
						curve = handler.getContentHandler().startCurve(id,
						coordinates[0],
						coordinates[1],
						coordinates[2],								
						srsName);					
					}					
					handler.getContentHandler().endCurve(curve);
				}
				break;
			case KXmlParser.TEXT:					

				break;
			}
			if (!endFeature){					
				currentTag = parser.next();
				tag = parser.getName();
			}
		}		

		return curve;	
	}
}
