package org.gvsig.gpe.gml.parser.sfp0.geometries;

import java.io.IOException;

import org.gvsig.gpe.gml.GMLTags;
import org.gvsig.gpe.gml.GPEDefaultGmlParser;
import org.gvsig.gpe.gml.parser.v2.geometries.GeometryBinding;
import org.gvsig.gpe.gml.utils.CompareUtils;
import org.kxml2.io.KXmlParser;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

public class LinestringSegmentTypeBinding extends GeometryBinding{
	public Object parse(XmlPullParser parser,GPEDefaultGmlParser handler) throws XmlPullParserException, IOException {
		boolean endFeature = false;
		int currentTag;
		Object linestringsegment = null;
		
		/********************************************************************
		 * Falta ver como pasar la informacin del tipo de interpolacion	*
		 * en el ContentHandler o en un hashtable de info para el usuario	*
		 * de la libreria, o crear una entrada de ContentHandler para cada 	*
		 * uno.																*			
		 ********************************************************************/
		String interpolacion = GMLTags.GML_DEFAULT_INTERPOLATION;
		
		for (int i=0 ; i<parser.getAttributeCount() ; i++){
			if (parser.getAttributeName(i).compareTo(GMLTags.GML_INTERPOLATION) == 0){
			    interpolacion = parser.getAttributeValue(i);
			}
		}
		
		super.setAtributtes(parser, handler.getErrorHandler());

		String tag = parser.getName();
		currentTag = parser.getEventType();

		while (!endFeature){
			switch(currentTag){
			case KXmlParser.START_TAG:
				if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_POSLIST)){
					double[][] coordinates = handler.getProfile().getPosListTypeBinding().
					parse(parser, handler);
					linestringsegment = handler.getContentHandler().startLineString(id,
							coordinates[0],
							coordinates[1],
							coordinates[2],								
							srsName);			
				}
				break;
			case KXmlParser.END_TAG:
				if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_LINESTRINGSEGMENT)){	
					endFeature = true;
				}
				break;
			case KXmlParser.TEXT:					

				break;
			}
			if (!endFeature){					
				currentTag = parser.next();
				tag = parser.getName();
			}
		}		
		return linestringsegment;	
	}
}
