package org.gvsig.gpe.gml.parser.sfp0.geometries;

import java.io.IOException;

import org.gvsig.gpe.gml.GMLTags;
import org.gvsig.gpe.gml.GPEGml2Parser;
import org.gvsig.gpe.gml.parser.v2.geometries.GeometryBinding;
import org.gvsig.gpe.gml.utils.CompareUtils;
import org.gvsig.gpe.gml.utils.CoordsContainer;
import org.kxml2.io.KXmlParser;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

public class MultiCurveTypeBinding extends GeometryBinding{
	/**************************
	 * Parse the object curve
	 **************************/
	public Object parse(XmlPullParser parser,GPEGml2Parser handler) throws XmlPullParserException, IOException {
		boolean endFeature = false;
		int currentTag;
		CoordsContainer coordsContainer = null;
		Object multiCurve = null;

		super.setAtributtes(parser, handler.getErrorHandler());
		
		//Taking the next tag
		multiCurve = handler.getContentHandler().startMultiCurve(id, srsName);
		
		String tag = parser.getName();
		currentTag = parser.getEventType();

		while (!endFeature){
			switch(currentTag){
			case KXmlParser.START_TAG:
					if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_CURVEMEMBER)){
						Object curve = CurveMemberTypeBinding.parse(parser, handler);
						handler.getContentHandler().addCurveToMultiCurve(curve, multiCurve);
					}
					break;
				case KXmlParser.END_TAG:
					if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_MULTICURVE)){						
						endFeature = true;	
						handler.getContentHandler().endMultiCurve(multiCurve);
					}
					break;
				case KXmlParser.TEXT:					
					
					break;
				}
				if (!endFeature){					
					currentTag = parser.next();
					tag = parser.getName();
				}
			}			
		return multiCurve;	
	}
}
