package org.gvsig.gpe.gml.parser.sfp0.geometries;

import java.io.IOException;

import org.gvsig.gpe.gml.GMLTags;
import org.gvsig.gpe.gml.GPEDefaultGmlParser;
import org.gvsig.gpe.gml.utils.CompareUtils;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;


/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id$
 * $Log$
 *
 */
/**
 * @author Jorge Piera LLodr (jorge.piera@iver.es)
 */
public class PolygonTypeBinding extends org.gvsig.gpe.gml.parser.v2.geometries.PolygonTypeBinding {

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.bindings.v2.geometries.PolygonTypeBinding#parseTag(org.xmlpull.v1.XmlPullParser, org.gvsig.gpe.gml.GPEDefaultGmlParser, java.lang.String, java.lang.String, java.lang.String)
	 */
	protected Object parseTag(XmlPullParser parser,GPEDefaultGmlParser handler, String tag, String id, String srsName) throws XmlPullParserException, IOException{
		this.polygon = super.parseTag(parser, handler, tag, id, srsName);
		if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_EXTERIOR)){
			double[][] coordinates = handler.getProfile().getExteriorTypeBinding().
			parse(parser, handler);
			this.polygon = handler.getContentHandler().startPolygon(id,
					coordinates[0],
					coordinates[1],
					coordinates[2],
					srsName);
		}else if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_INTERIOR)){
			double[][] coordinates = handler.getProfile().getInteriorTypeBinding().
			parse(parser, handler);
			Object innerPolygon = handler.getContentHandler().startInnerPolygon(null,
					coordinates[0],
					coordinates[1],
					coordinates[2],
					srsName);
			handler.getContentHandler().endInnerPolygon(innerPolygon);
			handler.getContentHandler().addInnerPolygonToPolygon(innerPolygon,this.polygon);
		}
		return this.polygon;		
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.gml.bindings.v2.geometries.PolygonTypeBinding#parseLastTag(org.xmlpull.v1.XmlPullParser, org.gvsig.gpe.gml.GPEDefaultGmlParser, java.lang.String)
	 */
	protected boolean parseLastTag(XmlPullParser parser,GPEDefaultGmlParser handler, String tag){
		boolean endFeature = super.parseLastTag(parser, handler, tag);
		if (endFeature){
			return true;
		}
		if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_SURFACE)){						
			return true;
		}
		return false;
	}
}
