package org.gvsig.gpe.gml.parser.sfp0.geometries;

import java.io.IOException;

import org.gvsig.gpe.gml.GMLTags;
import org.gvsig.gpe.gml.GPEDefaultGmlParser;
import org.gvsig.gpe.gml.parser.v2.geometries.DoubleTypeBinding;
import org.gvsig.gpe.gml.utils.CompareUtils;
import org.kxml2.io.KXmlParser;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

public class PosListTypeBinding {
	
	public double[][] parse(XmlPullParser parser,GPEDefaultGmlParser handler) throws XmlPullParserException, IOException  {
		boolean endFeature = false;
		int currentTag;
		String TUPLES_SEPARATOR  = GMLTags.GML_DEFAULT_TUPLES_SEPARATOR;
		String COORDINATES_DECIMAL = GMLTags.GML_DEFAULT_COORDINATES_DECIMAL;	
		
		int dimension = GMLTags.GML_DEFAULT_DIMENSION;
		int coordenada = 0;
		
		double[][] aCoordinates = null;
		
		for (int i=0 ; i<parser.getAttributeCount() ; i++){
			if (parser.getAttributeName(i).compareTo(GMLTags.GML_DIMENSION) == 0){
			    dimension = Integer.valueOf(parser.getAttributeValue(i)).intValue();
			}
		}		

		String tag = parser.getName();
		currentTag = parser.getEventType();

		while (!endFeature){
			switch(currentTag){
			case KXmlParser.START_TAG:
				if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_POSLIST)){
					parser.next();						
					String[] coordinates = parser.getText().trim().split(TUPLES_SEPARATOR);
					//Create new double arrays depending on dimension and number of coordinates
					aCoordinates = new double[3][coordinates.length/dimension];
					int i = 0;
					int tupla = 0;
					while (i<coordinates.length-1)
					{
						for (int j = 0; j < 3; j++)
						{
							String coordinate[] = coordinates[i].trim().split(TUPLES_SEPARATOR);
							switch (coordenada){
							case 0:
								aCoordinates[coordenada][tupla] = DoubleTypeBinding.parse(coordinate[0],COORDINATES_DECIMAL);
								coordenada ++;
								if (i<coordinates.length-1)
									i++;
								break;
							case 1:
								aCoordinates[coordenada][tupla] = DoubleTypeBinding.parse(coordinate[0],COORDINATES_DECIMAL);
								coordenada ++;
								if (i<coordinates.length-1)
									i++;
								break;
							case 2:
								if (dimension == 3){
									aCoordinates[coordenada][tupla] = DoubleTypeBinding.parse(coordinate[0],COORDINATES_DECIMAL);
									if (i<coordinates.length-1)
										i++;
								}
								else{
									aCoordinates[coordenada][tupla] = 0.0;
								}
								coordenada=0;
								break;
							}
						}	
						tupla ++;
					}
				}
				break;
			case KXmlParser.END_TAG:
				if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_POSLIST)){						
					endFeature = true;
				}
				break;
			case KXmlParser.TEXT:					

				break;
			}
			if (!endFeature){					
				currentTag = parser.next();
				tag = parser.getName();
			}
		}			
		return aCoordinates;	
	}
}
