package org.gvsig.gpe.gml.parser.sfp0.geometries;

import java.io.IOException;
import java.util.ArrayList;

import org.gvsig.gpe.gml.GMLTags;
import org.gvsig.gpe.gml.GPEDefaultGmlParser;
import org.gvsig.gpe.gml.utils.CompareUtils;
import org.gvsig.gpe.gml.utils.CoordsContainer;
import org.kxml2.io.KXmlParser;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

public class SegmentsTypeBinding{
	
	public ArrayList parse(XmlPullParser parser,GPEDefaultGmlParser handler) throws XmlPullParserException, IOException {
		boolean endFeature = false;
		int currentTag;
		CoordsContainer coordsContainer = null;
		ArrayList segments = new ArrayList();		

		String tag = parser.getName();
		currentTag = parser.getEventType();

		while (!endFeature){
			switch(currentTag){
			case KXmlParser.START_TAG:
				if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_LINESTRINGSEGMENT)){
					segments.add(handler.getProfile().getLinestringSegmentTypeBinding().
					parse(parser, handler));
				}else if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_LINESTRING)){
					segments.add(handler.getProfile().getLineStringTypeBinding().
					parse(parser, handler));
				}
				break;
			case KXmlParser.END_TAG:
				if (CompareUtils.compareWithOutNamespace(tag,GMLTags.GML_SEGMENTS)){	
					endFeature = true;
				}
				break;
			case KXmlParser.TEXT:					

				break;
			}
			if (!endFeature){					
				currentTag = parser.next();
				tag = parser.getName();
			}
		}		
		return segments;	
	}
}
