package org.gvsig.gpe.gml.writer.v2.features;

import java.io.IOException;

import org.gvsig.gpe.gml.GMLTags;
import org.gvsig.gpe.gml.writer.GPEGmlWriterHandlerImplementor;
import org.gvsig.gpe.xml.writer.Writer;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: GidWriter.java 350 2008-01-09 12:53:07Z jpiera $
 * $Log$
 * Revision 1.4  2007/05/15 08:11:54  jorpiell
 * The element had to have end
 *
 * Revision 1.3  2007/05/14 09:32:12  jorpiell
 * Add the a new class to compare tags
 *
 * Revision 1.2  2007/05/08 10:24:16  jorpiell
 * Add comments to create javadocs
 *
 * Revision 1.1  2007/04/17 07:00:35  jorpiell
 * GML name, descripction and Id tags separated
 *
 *
 */
/**
 * This class writes the gml:description tag. Example:
 * <p>
 * <pre>
 * <code>
 * &lt;gml:gid&gt;5&lt;/gml:gid&gt;
 * </code>
 * </pre>
 * </p>
 * @author Jorge Piera LLodr (jorge.piera@iver.es)
 */
public class GidWriter {
	
	/**
	 * It writes a GID tag
	 * @param writer
	 * Writer to write the labels
	 * @param handler
	 * The writer handler implementor
	 * @param id
	 * ID value
	 * @throws IOException
	 */
	public void write(Writer writer, GPEGmlWriterHandlerImplementor handler, String id) throws IOException{
		if (id != null){
			writer.write("\n");
			writer.write("<" + GMLTags.GML_NAMESPACE + ":" + GMLTags.GML_GID + ">");
			writer.write(id);
			writer.write("</" + GMLTags.GML_NAMESPACE + ":" + GMLTags.GML_GID + ">");
		}
	}
}
