package org.gvsig.gpe.xml.writer;

import java.io.IOException;
import java.io.OutputStream;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: Writer.java 173 2007-11-06 12:10:57Z jpiera $
 * $Log$
 * Revision 1.2  2007/05/16 15:55:01  jorpiell
 * Add toString method
 *
 * Revision 1.1  2007/04/14 16:07:30  jorpiell
 * The writer has been created
 *
 *
 */
/**
 * @author Jorge Piera LLodr (jorge.piera@iver.es)
 */
public class Writer {
	private java.io.Writer writer = null;
	private OutputStream os = null;

	public Writer(java.io.Writer writer) {
		super();
		this.writer = writer;
	}	

	public Writer(OutputStream os){
		super();
		this.os = os;
	}

	public void write(String string) throws IOException{
		if (writer != null){
			writer.write(string);
		}else{
			os.write(string.getBytes());
		}
	}

	public void flush() throws IOException{
		if (writer != null){
			writer.flush();
		}else{
			os.flush();
		}
	}

	public void close() throws IOException{
		if (writer != null){
			writer.close();
		}else{
			os.close();
		}
	}

	public String toString(){
		if (writer != null){
			return writer.toString();
		}else{
			return os.toString();
		}
	}
}
