package org.gvsig.gpe.kml;
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: KmlTags.java 136 2007-05-16 15:54:36Z jorpiell $
 * $Log$
 * Revision 1.10  2007/05/16 15:54:20  jorpiell
 * Add elements support
 *
 * Revision 1.9  2007/05/15 12:37:45  jorpiell
 * Add multyGeometries
 *
 * Revision 1.8  2007/05/09 08:36:24  jorpiell
 * Add the bbox to the layer
 *
 * Revision 1.7  2007/05/08 09:28:17  jorpiell
 * Add comments to create javadocs
 *
 * Revision 1.6  2007/05/08 07:53:08  jorpiell
 * Add comments to the writers
 *
 * Revision 1.5  2007/05/02 11:46:50  jorpiell
 * Writing tests updated
 *
 * Revision 1.4  2007/04/20 08:38:59  jorpiell
 * Tests updating
 *
 * Revision 1.3  2007/04/14 16:08:07  jorpiell
 * Kml writing support added
 *
 * Revision 1.2  2007/04/13 13:16:21  jorpiell
 * Add KML reading support
 *
 * Revision 1.1  2007/03/07 08:19:10  jorpiell
 * Pasadas las clases de KML de libGPE-GML a libGPE-KML
 *
 * Revision 1.1  2007/02/28 11:48:31  csanchez
 * *** empty log message ***
 *
 * Revision 1.1  2007/02/20 10:53:20  jorpiell
 * Añadidos los proyectos de kml y gml antiguos
 *
 * Revision 1.1  2007/02/12 13:49:18  jorpiell
 * Aadido el driver de KML
 *
 *
 */
/**
 * Just some KML tags retreived from its specification
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class KmlTags {
	public static final String ROOT = "kml";
	
	public static final String PLACEMARK = "Placemark";
	public static final String OPEN = "open";
	public static final String GROUNDOVERLAY = "GroundOverlay";
		
	public static final String POINT = "Point";
	public static final String COORDINATES = "coordinates";
	public static final String LINESTRING = "LineString";
	public static final String LINEARRING = "LinearRing";
	public static final String POLYGON = "Polygon";	
	public static final String OUTERBOUNDARYIS = "outerBoundaryIs";	
	public static final String INNERBOUNDARYIS = "innerBoundaryIs";	
	public static final String MULTIGEOMETRY = "MultiGeometry";
	
	public static final String DOCUMENT = "Document";
	public static final String FOLDER = "Folder";
	public static final String STYLE = "Style";
		
	//Separator between coordinates
	public static final String COORDINATES_SEPARATOR = ",";
	public static final String TUPLES_SEPARATOR = "\n";
	
	//PlaceMark params
	public static final String NAME = "name";
	public static final String DESCRIPTION = "description";
	public static final String VISIBILITY = "visibility";
	public static final String LOOKAT = "LookAt";
	public static final String STYLEURL = "styleUrl";
	
	//Param added to each feature to create the legend
	public static final String FOLDER_NAME = "Folder Name";
	
	//Name for the default legend
	public static final String DEFAULT_LEGEND = "Default";
	
	//LookAt params
	public static final String LONGITUDE = "longitude";
	public static final String LATITUDE = "latitude";
	public static final String ALTITUDE = "altitude";
	public static final String RANGE = "range";
	public static final String TILT = "tilt";
	public static final String HEADING = "heading";
	
	//LatLonBox params
	public static final String LATLONALTBOX = "LatLonAltBox";
	public static final String LATLONBOX = "LatLonBox";
	public static final String REGION = "Region";
	public static final String NORTH = "north";
	public static final String SOUTH = "south";
	public static final String EAST = "east";
	public static final String WEST = "west";
	public static final String MINALTITUDE = "minAltitude";
	public static final String MAXALTITUDE = "maxAltitude";
	public static final String ALTITUDEMODE = "altitudeMode";
	public static final String ROTATION = "rotation";
		
	//Others
	public static final String UNKNOWN_VERSION = "UnknownVersion";
	public static final String DEFAULT_SRS = "EPSG:4326";
	public static final String NAMESPACE_21 = "http://earth.google.com/kml/2.1";
	public static final String ID = "id"; 
	public static final String GEOMETRY_ID = "id"; 
	public static final String METADATA = "Metadata";
}
