package org.gvsig.gpe.exceptions;

import java.util.Hashtable;
import java.util.Map;

import org.gvsig.exceptions.BaseException;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: GPERegisterException.java 144 2007-06-07 14:53:59Z jorpiell $
 * $Log$
 * Revision 1.2  2007/06/07 14:52:28  jorpiell
 * Add the schema support
 *
 * Revision 1.1  2007/05/08 12:57:14  jorpiell
 * Add the register exceptions
 *
 *
 */
/**
 * This exception is throwed when a GPEParser or a 
 * GPEWriterHandler haven't could be registered
 * @author Jorge Piera LLodr (jorge.piera@iver.es)
 */
public abstract class GPERegisterException extends BaseException{
	private Class clazz = null;
	private String name = null;
	private String type = null; 
	
	/**
	 * Constructor
	 * @param name
	 * Name used to register the class
	 * @param clazz
	 * GPEParser Class
	 * @param type
	 * Registered type (a GPEParser or a GPEWriterHandler)
	 * @param code
	 * Exception code
	 * @param exception
	 * Cause of the Exception
	 */
	public GPERegisterException(String name, Class clazz, String type, Throwable exception, long code) {
		this.name = name;
		this.type = type;
		this.clazz = clazz;
		this.code = code;
		initialize();
		initCause(exception);
	}
	
	/**
	 * Initialize the properties
	 */
	private void initialize() {
		messageKey = "gpe_register_exception";
		formatString = "Error registering the class %(class) " +
				"using the name %(name) into the %(type)s list";
	}
	
	/*
	 *  (non-Javadoc)
	 * @see org.gvsig.exceptions.BaseException#values()
	 */
	protected Map values() {
		Hashtable params = new Hashtable();
		params.put("name",name);
		params.put("class", clazz.getName());
		params.put("type", type);
		return params;	
	}
	
}
