package com.iver.utiles.stringNumberUtilities;

import junit.framework.TestCase;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

/**
 * Tests the methods of the class StringNumberUtilities
 * 
 * @author Pablo Piqueras Bartolom (p_queras@hotmail.com)
 */
public class TestStringNumberUtilities extends TestCase{
	private String word;
	
	/*
	 *  (non-Javadoc)
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		word = new String();
	}

	/*
	 *  (non-Javadoc)
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	/**
	 * A test
	 */
	public void test1() {
		word = "2.3";
		ShowText.showIsNumberText(word);

		if (StringNumberUtilities.isNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test2() {
		word = "a as wz rwa";
		ShowText.showIsNumberText(word);

		if (StringNumberUtilities.isNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test3() {
		word = "2";
		ShowText.showIsNumberText(word);

		if (StringNumberUtilities.isNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test4() {
		word = "";
		ShowText.showIsNumberText(word);

		if (StringNumberUtilities.isNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test5() {
		word = "-2.3";
		ShowText.showIsNumberText(word);

		if (StringNumberUtilities.isNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test6() {
		word = "-300";
		ShowText.showIsNumberText(word);

		if (StringNumberUtilities.isNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test7() {
		word = "2.3";
		ShowText.showIsNaturalText(word);

		if (StringNumberUtilities.isNaturalNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test8() {
		word = "334";
		ShowText.showIsNaturalText(word);

		if (StringNumberUtilities.isNaturalNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test9() {
		word = "-2a3";
		ShowText.showIsIntegerText(word);

		if (StringNumberUtilities.isIntegerNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test10() {
		word = "-23";
		ShowText.showIsIntegerText(word);

		if (StringNumberUtilities.isIntegerNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	/**
	 * A test
	 */
	public void test11() {
		word = "7";
		ShowText.showIsIntegerText(word);

		if (StringNumberUtilities.isIntegerNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	/**
	 * A test
	 */
	public void test12() {
		word = "2.3";
		ShowText.showIsIntegerText(word);

		if (StringNumberUtilities.isIntegerNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test13() {
		word = "2.3";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	/**
	 * A test
	 */
	public void test14() {
		word = "37";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	/**
	 * A test
	 */
	public void test15() {
		word = "-4.6";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	/**
	 * A test
	 */
	public void test16() {
		word = "-8000";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}

	/**
	 * A test
	 */
	public void test17() {
		word = "-80k00";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
		
	/**
	 * A test
	 */
	public void test18() {
		word = ".6";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	/**
	 * A test
	 */
	public void test19() {
		word = "-.6";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	/**
	 * A test
	 */
	public void test20() {
		word = "b-.6";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	
	/**
	 * A test
	 */
	public void test21() {
		word = "-c.6";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	
	/**
	 * A test
	 */
	public void test22() {
		word = "-.d6";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	/**
	 * A test
	 */
	public void test23() {
		word = "-.6e";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	/**
	 * A test
	 */
	public void test24() {
		word = "+.6";
		ShowText.showIsRealText(word);

		if (StringNumberUtilities.isRealNumber(word)) {
			ShowText.showYes();
		}
		else {
			ShowText.showNo();
			fail();
		}
	}
	
	/**
	 * Shows a text sentence
	 * 
	 * @author Pablo Piqueras Bartolom (p_queras@hotmail.com)
	 */
	private static class ShowText {
		/**
		 * Shows the text: Is number?
		 * 
		 * @param word An String
		 */
		public static void showIsNumberText(String word) {
			System.out.print(" Es nmero \'" + word + "\' ? ");
		}

		/**
		 * Shows the text: Is natural number?
		 * 
		 * @param word An String
		 */
		public static void showIsNaturalText(String word) {
			System.out.print(" Es nmero natural \'" + word + "\' ? ");
		}

		/**
		 * Shows the text: Is integer number?
		 * 
		 * @param word An String
		 */
		public static void showIsIntegerText(String word) {
			System.out.print(" Es nmero entero \'" + word + "\' ? ");
		}

		/**
		 * Shows the text: Is rational number?
		 * 
		 * @param word An String
		 */
		public static void showIsRealText(String word) {
			System.out.print(" Es nmero real \'" + word + "\' ? ");
		}
		
		/**
		 * Shows the text: Yes
		 * 
		 * @param word An String
		 */
		public static void showYes() {
			System.out.println("Si.");
		}
		
		/**
		 * Shows the text: No
		 * 
		 * @param word An String
		 */
		public static void showNo() {
			System.out.println("No.");
		}
	}
}
