/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

/* CVS MESSAGES:
*
* $Id: TestXMLEntity.java 6875 2006-08-29 06:18:17Z jaume $
* $Log$
* Revision 1.1  2006-08-29 06:18:17  jaume
* *** empty log message ***
*
*
*/
package com.iver.utiles;

import junit.framework.TestCase;

public class TestXMLEntity extends TestCase {
	XMLEntity x1, x2, x3, x4;

	public void setUp() {
		x1 = new XMLEntity();
		x2 = new XMLEntity();
		x3 = new XMLEntity();

		
		Object obj1 = new XMLEntity();
		Object obj2 = new XMLEntity();
		Object obj3 = "StringClass";

		
		x1.putProperty("boolean1", false);
		x1.putProperty("boolean2", true);

		x1.putProperty("integer1", Integer.parseInt("123"));
		x1.putProperty("integer2", Integer.parseInt("321"));

		x1.putProperty("long1", Long.parseLong("123123"));
		x1.putProperty("long2", Long.parseLong("321321"));

		x1.putProperty("float1", Float.parseFloat("1234.1234"));
		x1.putProperty("float2", Float.parseFloat("4321.4321"));

		x1.putProperty("double1", Double.parseDouble("12341234.12341234"));
		x1.putProperty("double2", Double.parseDouble("43214321.43214321"));

		x1.putProperty("string1", "String1");
		x1.putProperty("string2", "String2");

		x1.putProperty("object1", obj1);
		x1.putProperty("object2", obj2);


		//----- x1 == x2
		x2.putProperty("boolean1", false);
		x2.putProperty("boolean2", true);

		x2.putProperty("integer1", Integer.parseInt("123"));
		x2.putProperty("integer2", Integer.parseInt("321"));

		x2.putProperty("long1", Long.parseLong("123123"));
		x2.putProperty("long2", Long.parseLong("321321"));

		x2.putProperty("float1", Float.parseFloat("1234.1234"));
		x2.putProperty("float2", Float.parseFloat("4321.4321"));

		x2.putProperty("double1", Double.parseDouble("12341234.12341234"));
		x2.putProperty("double2", Double.parseDouble("43214321.43214321"));

		x2.putProperty("string1", "String1");
		x2.putProperty("string2", "String2");

		x2.putProperty("object1", obj1);
		x2.putProperty("object2", obj2);

		
		//----- x1 != x3

		x3.putProperty("boolean1", false);
		x3.putProperty("boolean2", true);

		x3.putProperty("integer1", Integer.parseInt("123"));
		x3.putProperty("integer2", Integer.parseInt("321"));

		x3.putProperty("long1", Long.parseLong("123123"));
		x3.putProperty("long2", Long.parseLong("321321"));

		x3.putProperty("float1", Float.parseFloat("1234.1234"));
		x3.putProperty("float2", Float.parseFloat("4321.4321"));

		x3.putProperty("double1", Double.parseDouble("12341234.12341234"));
		x3.putProperty("double2", Double.parseDouble("43214321.43214324"));

		x3.putProperty("string1", "String1");
		x3.putProperty("string2", "String2");

		x3.putProperty("object1", obj1);
		x3.putProperty("object2", obj3);

	}

	public void testEquality() {
		assertTrue(x1.equals(x2));

		assertFalse(x1.equals(x3));
		assertFalse(x2.equals(x3));
	}

	public void testHash() {
		assertTrue(x1.hashCode() == x2.hashCode());
		assertTrue(x1.hashCode() != x3.hashCode());
	}
}
