package org.gvsig.remoteClient.gml.engine;

import org.gvsig.remoteClient.gml.engine.readers.IReaderFile;
import org.gvsig.remoteClient.gml.factories.IGeometriesFactory;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: AbstractFeaturesParser.java 10269 2007-02-12 13:51:08Z jorpiell $
 * $Log$
 * Revision 1.1  2007-02-12 13:49:18  jorpiell
 * Aadido el driver de KML
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public abstract class AbstractFeaturesParser implements IFeaturesParser{
	protected IReaderFile reader = null;	;
	protected IGeometriesFactory gFactory = null;
	
	public AbstractFeaturesParser(IReaderFile reader,IGeometriesFactory gFactory){
		this.reader = reader;
		this.gFactory = gFactory;
	}

	/**
	 * @return Returns the gFactory.
	 */
	public IGeometriesFactory getGFactory() {
		return gFactory;
	}

	/**
	 * @return Returns the reader.
	 */
	public IReaderFile getReader() {
		return reader;
	}
	
}
