package org.gvsig.remoteClient.gml.engine;

import java.awt.geom.Rectangle2D;

import org.gvsig.remoteClient.gml.exceptions.GMLException;
import org.gvsig.remoteClient.gml.exceptions.GMLExceptionList;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: IDriver.java 18271 2008-01-24 09:06:43Z jpiera $
 * $Log$
 * Revision 1.1  2007-02-12 13:49:18  jorpiell
 * Aadido el driver de KML
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public interface IDriver {
	
	/**
	 * Gets the iteartor used to retrieve all the features
	 * @return
	 */
	public IFeaturesIterator getFeaturesIterator() throws GMLException;	
	
	/**
	 * @return Returns the extent.
	 */	
	public Rectangle2D getExtent();
	
	/**
	 * @return Returns the SRS
	 */	
	public String getSRS();
	
	/**
	 * @return Returns the version.
	 */
	public String getVersion();
	
	/**
	 * @return Returns a list of codes with information to the user about parse.
	 */
	public  GMLExceptionList getWarnings();
}
