/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

/* CVS MESSAGES:
*
* $Id: ICancellable.java 13411 2007-08-31 12:55:05Z ppiqueras $
* $Log$
* Revision 1.1.4.2  2007-08-31 12:51:44  ppiqueras
* Translated comments to English language and add new ones.
*
* Revision 1.1.4.1  2007/07/13 10:39:12  jorpiell
* Cuando se cambia el zoom de una capa solo se suspenden las descargas pendientes que afectan a esa capa.
*
* Revision 1.1  2006/05/24 16:37:34  jaume
* *** empty log message ***
*
*
*/
package org.gvsig.remoteClient.wms;

/**
 * <p>When a task is accessing to remote data, takes an indeterminate time, and some times gets locked. This
 * is the reason which this kind of task can be canceled.</p>
 * <p>The <code>ICancellable</code> interface is designed for get information about the cancellation of a
 * task related to the download of remote information.</p>
 */
public interface ICancellable {
	/**
	 * <p>Returns <code>true</code> if a download or a group of downloads has been canceled.</p>
	 * 
	 * @return <code>true</code> if a download or a group of downloads has been canceled, otherwise <code>false</code>
	 */
	public boolean isCanceled();	
	
	/**
	 * <p>Used to cancel only a group of downloads with the same identifier.</p>
	 * 
	 * @return the identifier
	 */
	public Object getID();
}
