/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package org.gvsig.gui.beans.graphic;

import java.awt.FlowLayout;

import javax.swing.JPanel;

import org.gvsig.gui.beans.textincreaser.TextIncreaserContainer;

/**
 * 
 * Nacho Brodin (brodin_ign@gva.es)
 */

public class BoxesPanel extends JPanel {
	
	private int 				width = 300, height = 30;
	private JPanel pLeft = null;
	private JPanel pRight = null;
	private TextIncreaserContainer controlLeft = null;
	private TextIncreaserContainer controlRight = null;
	public BoxesPanel(int width, int height) {
		super();
		this.width = width;
		this.height = height;
		initialize(); 
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
        FlowLayout flowLayout = new FlowLayout();
        flowLayout.setHgap(0);
        flowLayout.setVgap(0);
        this.setLayout(flowLayout);
        this.setSize(new java.awt.Dimension(width, height));
        this.setPreferredSize(new java.awt.Dimension(width, height));
        this.add(getPLeft(), null);
        this.add(getPRight(), null);
			
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPLeft() {
		if (pLeft == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setHgap(0);
			flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout1.setVgap(0);
			pLeft = new JPanel();
			pLeft.setLayout(flowLayout1);
			pLeft.add(getControlLeft(), null);
			pLeft.setSize(new java.awt.Dimension(width >> 1, height));
	        pLeft.setPreferredSize(new java.awt.Dimension(width >> 1, height));
		}
		return pLeft;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPRight() {
		if (pRight == null) {
			FlowLayout flowLayout2 = new FlowLayout();
			flowLayout2.setHgap(0);
			flowLayout2.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout2.setVgap(0);
			pRight = new JPanel();
			pRight.setLayout(flowLayout2);
			pRight.add(getControlRight(), null);
			pRight.setSize(new java.awt.Dimension(width >> 1, height));
			pRight.setPreferredSize(new java.awt.Dimension(width >> 1, height));
		}
		return pRight;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public TextIncreaserContainer getControlLeft() {
		if (controlLeft == null) {
			controlLeft = new TextIncreaserContainer(70, 0, 100, 0.0, true);
		}
		return controlLeft;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public TextIncreaserContainer getControlRight() {
		if (controlRight == null) {
			controlRight = new TextIncreaserContainer(70, 0, 100, 100.0, false);
		}
		return controlRight;
	}
	
	/**
	 * Asigna el tamao del componente
	 * @param w Nuevo ancho del componente padre
	 * @param h Nuevo alto del componente padre
	 */
	public void setComponentSize(int w, int h){
		this.width = w;
		this.height = h;
		setSize(w, h);
		setPreferredSize(new java.awt.Dimension(w, h));
		getPRight().setSize(w >> 1, h);
		getPRight().setPreferredSize(new java.awt.Dimension(w >> 1, h));
		getPLeft().setSize(w >> 1, h);
		getPLeft().setPreferredSize(new java.awt.Dimension(w >> 1, h));
		
	}
	
	//****************************************************
	//MTODOS DEL CONTROL
	
	/**
	 * Obtiene el valor de los controles. 
	 * @return Array con los valores de ambos controles. El primer valor del array es el control de la derecha
	 * y el segundo el de la izquierda.  
	 */
	public double[] getBoxesValues(){
		double[] v = new double[2];
		v[0] = getControlRight().getValue();
		v[1] = getControlLeft().getValue();
		return v;
	}
}
