/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package org.gvsig.gui.beans.graphic;

import java.awt.Color;
import java.awt.FlowLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;

import org.gvsig.gui.beans.graphic.listeners.GraphicListener;

/**
 * 
 * Nacho Brodin (brodin_ign@gva.es)
 */

public class DoubleSliderControlPanel extends JPanel {
	
	private int 				width = 300, height = 25;
	private JLabel 				lLeft = null;
	private JLabel 				lRight = null;
	private GraphicListener 	graphicListener = null;
	private JPanel pRight = null;
	private JPanel pLeft = null;
	
	public DoubleSliderControlPanel(int width, int height, GraphicListener 	graphicListener) {
		super();
		this.width = width;
		this.height = height;
		this.graphicListener = graphicListener;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
        FlowLayout flowLayout = new FlowLayout();
        flowLayout.setHgap(0);
        flowLayout.setAlignment(java.awt.FlowLayout.LEFT);
        flowLayout.setVgap(0);
        
        /*lRight = new JLabel();
        lRight.setForeground(Color.RED);
        lRight.setText("T");
        lRight.setPreferredSize(new java.awt.Dimension(15,25));
        
        lLeft = new JLabel();
        lLeft.setForeground(Color.BLUE);
        lLeft.setText("T");
        lLeft.setPreferredSize(new java.awt.Dimension(15,25));
        this.setLayout(flowLayout);
        
        lRight.addMouseListener(graphicListener);
        lRight.addMouseMotionListener(graphicListener);
        lLeft.addMouseListener(graphicListener);
        lLeft.addMouseMotionListener(graphicListener);
        graphicListener.setLabels(lLeft, lRight);*/
       
        this.setLayout(flowLayout);
        this.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
        this.setSize(new java.awt.Dimension(width, height));
        this.setPreferredSize(new java.awt.Dimension(width, height));
  
        this.add(getPLeft(), null);
        this.add(getPRight(), null);
        graphicListener.setLabels(lLeft, lRight);
        
        //lLeft.setLocation(28, 4);
        //lRight.setLocation(470, 4);
        
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPRight() {
		if (pRight == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setHgap(0);
			flowLayout1.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout1.setVgap(0);
			lRight = new JLabel();
			lRight.setText("T");
			lRight.setForeground(Color.RED);
			lRight.setPreferredSize(new java.awt.Dimension(15,22));
			pRight = new JPanel();
			pRight.setLayout(flowLayout1);
			pRight.setPreferredSize(new java.awt.Dimension((width >> 1) - 2,20));
			pRight.setSize(width >> 1,20);
			pRight.add(lRight, null);
	        lRight.addMouseListener(graphicListener);
	        lRight.addMouseMotionListener(graphicListener);
		}
		return pRight;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPLeft() {
		if (pLeft == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setHgap(28);
			flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout1.setVgap(0);
			lLeft = new JLabel();
			lLeft.setText("T");
			lLeft.setForeground(Color.BLUE);
			lLeft.setPreferredSize(new java.awt.Dimension(15,22));
			pLeft = new JPanel();
			pLeft.setLayout(flowLayout1);
			pLeft.setPreferredSize(new java.awt.Dimension((width >> 1) - 2,20));
			pLeft.setSize(width >> 1,20);
			pLeft.add(lLeft, null);
			lLeft.addMouseListener(graphicListener);
	        lLeft.addMouseMotionListener(graphicListener);
		}
		return pLeft;
	}

}
